<?php
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *                                   ATTENTION!
 * If you see this message in your browser (Internet Explorer, Mozilla Firefox, Google Chrome, etc.)
 * this means that PHP is not properly installed on your web server. Please refer to the PHP manual
 * for more details: http://php.net/manual/install.php 
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

    include_once dirname(__FILE__) . '/components/startup.php';
    include_once dirname(__FILE__) . '/components/application.php';
    include_once dirname(__FILE__) . '/' . 'authorization.php';


    include_once dirname(__FILE__) . '/' . 'database_engine/pgsql_engine.php';
    include_once dirname(__FILE__) . '/' . 'components/page/page_includes.php';

    function GetConnectionOptions()
    {
        $result = GetGlobalConnectionOptions();
        $result['client_encoding'] = 'utf8';
        GetApplication()->GetUserAuthentication()->applyIdentityToConnectionOptions($result);
        return $result;
    }

    
    
    
    // OnBeforePageExecute event handler
    
    
    
    class public_tariff_edm_configPage extends Page
    {
        protected function DoBeforeCreate()
        {
            $this->SetTitle('');
            $this->SetMenuLabel('Periodenvorlage');
            $this->SetHeader(GetPagesHeader());
            $this->SetFooter(GetPagesFooter());
    
            $this->dataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_config"');
            $this->dataset->addFields(
                array(
                    new IntegerField('id', true, true, true),
                    new StringField('period'),
                    new StringField('action_type'),
                    new StringField('data_type'),
                    new StringField('inclusion'),
                    new StringField('exclusion'),
                    new StringField('tariff'),
                    new IntegerField('quantity_percent'),
                    new IntegerField('quantity'),
                    new StringField('remark'),
                    new StringField('origin_gln'),
                    new StringField('disposition_gln'),
                    new StringField('waste_gtin'),
                    new IntegerField('multiply'),
                    new StringField('o_street'),
                    new StringField('o_street_extension'),
                    new StringField('o_country'),
                    new StringField('o_zip'),
                    new StringField('o_city'),
                    new StringField('d_street'),
                    new StringField('d_street_extension'),
                    new StringField('d_country'),
                    new StringField('d_zip'),
                    new StringField('d_city'),
                    new StringField('o_name'),
                    new StringField('d_name'),
                    new StringField('report_gln'),
                    new StringField('zip_inclusion'),
                    new StringField('zip_exclusion'),
                    new StringField('cat_inclusion'),
                    new StringField('cat_exclusion')
                )
            );
            $this->dataset->AddLookupField('action_type', 'public.tariff_edm_activity_types', new StringField('activity_type'), new StringField('description', false, false, false, false, 'LA1', 'LT1'), 'LT1');
            $this->dataset->AddLookupField('waste_gtin', 'public.qwaste_catalog', new StringField('gtin'), new StringField('selector', false, false, false, false, 'LA2', 'LT2'), 'LT2');
            $this->dataset->AddLookupField('tariff', 'public.qtariff_select', new StringField('id'), new StringField('selector', false, false, false, false, 'LA3', 'LT3'), 'LT3');
            $this->dataset->AddLookupField('origin_gln', 'public.qgln_select', new StringField('gln'), new StringField('description', false, false, false, false, 'LA4', 'LT4'), 'LT4');
            $this->dataset->AddLookupField('disposition_gln', 'public.qgln_select', new StringField('gln'), new StringField('description', false, false, false, false, 'LA5', 'LT5'), 'LT5');
            $this->dataset->AddLookupField('report_gln', 'public.contact_edm_gln', new StringField('gln'), new StringField('description', false, false, false, false, 'LA6', 'LT6'), 'LT6');
        }
    
        protected function DoPrepare() {
    
        }
    
        protected function CreatePageNavigator()
        {
            $result = new CompositePageNavigator($this);
            
            $partitionNavigator = new PageNavigator('pnav', $this, $this->dataset);
            $partitionNavigator->SetRowsPerPage(10);
            $result->AddPageNavigator($partitionNavigator);
            
            return $result;
        }
    
        protected function CreateRssGenerator()
        {
            return null;
        }
    
        protected function setupCharts()
        {
    
        }
    
        protected function getFiltersColumns()
        {
            return array(
                new FilterColumn($this->dataset, 'id', 'id', 'ID'),
                new FilterColumn($this->dataset, 'period', 'period', 'Jahr'),
                new FilterColumn($this->dataset, 'action_type', 'LA1', 'Typ'),
                new FilterColumn($this->dataset, 'data_type', 'data_type', 'Quelle'),
                new FilterColumn($this->dataset, 'waste_gtin', 'LA2', 'Abfallart'),
                new FilterColumn($this->dataset, 'tariff', 'LA3', 'Tarif'),
                new FilterColumn($this->dataset, 'exclusion', 'exclusion', 'Ausschluss'),
                new FilterColumn($this->dataset, 'inclusion', 'inclusion', 'Einschluss'),
                new FilterColumn($this->dataset, 'zip_exclusion', 'zip_exclusion', 'PLZ Ausschluss'),
                new FilterColumn($this->dataset, 'zip_inclusion', 'zip_inclusion', 'PLZ Einschluss'),
                new FilterColumn($this->dataset, 'cat_exclusion', 'cat_exclusion', 'CRM Typ Ausschluss'),
                new FilterColumn($this->dataset, 'cat_inclusion', 'cat_inclusion', 'CRM Typ Einschluss'),
                new FilterColumn($this->dataset, 'quantity', 'quantity', 'Masse'),
                new FilterColumn($this->dataset, 'origin_gln', 'LA4', 'Herkunft'),
                new FilterColumn($this->dataset, 'disposition_gln', 'LA5', 'Verbleib'),
                new FilterColumn($this->dataset, 'quantity_percent', 'quantity_percent', 'Prozent Menge'),
                new FilterColumn($this->dataset, 'remark', 'remark', 'Beschreibung'),
                new FilterColumn($this->dataset, 'multiply', 'multiply', 'Multiplikator'),
                new FilterColumn($this->dataset, 'o_street', 'o_street', 'Herkunft Strasse'),
                new FilterColumn($this->dataset, 'o_street_extension', 'o_street_extension', 'Herkunft Strassennummer'),
                new FilterColumn($this->dataset, 'o_country', 'o_country', 'Herkunft Land'),
                new FilterColumn($this->dataset, 'o_zip', 'o_zip', 'Herkunft PLZ'),
                new FilterColumn($this->dataset, 'o_city', 'o_city', 'Herkunft Stadt'),
                new FilterColumn($this->dataset, 'd_street', 'd_street', 'Verbleib Strasse'),
                new FilterColumn($this->dataset, 'd_street_extension', 'd_street_extension', 'Verbleib Strassennummer'),
                new FilterColumn($this->dataset, 'd_country', 'd_country', 'Verbleib Land'),
                new FilterColumn($this->dataset, 'd_zip', 'd_zip', 'Verbleib PLZ'),
                new FilterColumn($this->dataset, 'd_city', 'd_city', 'Verbleib Stadt'),
                new FilterColumn($this->dataset, 'o_name', 'o_name', 'Herkunft Name'),
                new FilterColumn($this->dataset, 'd_name', 'd_name', 'Verbleib Name'),
                new FilterColumn($this->dataset, 'report_gln', 'LA6', 'Report GLN')
            );
        }
    
        protected function setupQuickFilter(QuickFilter $quickFilter, FixedKeysArray $columns)
        {
            $quickFilter
                ->addColumn($columns['id'])
                ->addColumn($columns['period'])
                ->addColumn($columns['action_type'])
                ->addColumn($columns['data_type'])
                ->addColumn($columns['waste_gtin'])
                ->addColumn($columns['tariff'])
                ->addColumn($columns['exclusion'])
                ->addColumn($columns['inclusion'])
                ->addColumn($columns['zip_exclusion'])
                ->addColumn($columns['zip_inclusion'])
                ->addColumn($columns['cat_exclusion'])
                ->addColumn($columns['cat_inclusion'])
                ->addColumn($columns['quantity'])
                ->addColumn($columns['origin_gln'])
                ->addColumn($columns['disposition_gln'])
                ->addColumn($columns['quantity_percent'])
                ->addColumn($columns['remark'])
                ->addColumn($columns['multiply'])
                ->addColumn($columns['report_gln']);
        }
    
        protected function setupColumnFilter(ColumnFilter $columnFilter)
        {
            $columnFilter
                ->setOptionsFor('period')
                ->setOptionsFor('action_type')
                ->setOptionsFor('data_type')
                ->setOptionsFor('waste_gtin')
                ->setOptionsFor('tariff')
                ->setOptionsFor('exclusion')
                ->setOptionsFor('inclusion')
                ->setOptionsFor('zip_exclusion')
                ->setOptionsFor('zip_inclusion')
                ->setOptionsFor('origin_gln')
                ->setOptionsFor('disposition_gln')
                ->setOptionsFor('report_gln');
        }
    
        protected function setupFilterBuilder(FilterBuilder $filterBuilder, FixedKeysArray $columns)
        {
            $main_editor = new TextEdit('id_edit');
            
            $filterBuilder->addColumn(
                $columns['id'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('period_edit');
            
            $filterBuilder->addColumn(
                $columns['period'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('action_type_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_tariff_edm_config_action_type_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('action_type', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_tariff_edm_config_action_type_search');
            
            $text_editor = new TextEdit('action_type');
            
            $filterBuilder->addColumn(
                $columns['action_type'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new ComboBox('data_type_edit', $this->GetLocalizerCaptions()->GetMessageString('PleaseSelect'));
            $main_editor->addChoice('ls', 'Lieferschein');
            $main_editor->addChoice('manuell', 'Manuell');
            $main_editor->SetAllowNullValue(false);
            
            $multi_value_select_editor = new MultiValueSelect('data_type');
            $multi_value_select_editor->setChoices($main_editor->getChoices());
            
            $text_editor = new TextEdit('data_type');
            
            $filterBuilder->addColumn(
                $columns['data_type'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('waste_gtin_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_tariff_edm_config_waste_gtin_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('waste_gtin', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_tariff_edm_config_waste_gtin_search');
            
            $text_editor = new TextEdit('waste_gtin');
            
            $filterBuilder->addColumn(
                $columns['waste_gtin'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('tariff_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_tariff_edm_config_tariff_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('tariff', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_tariff_edm_config_tariff_search');
            
            $text_editor = new TextEdit('tariff');
            
            $filterBuilder->addColumn(
                $columns['tariff'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('exclusion_edit');
            
            $filterBuilder->addColumn(
                $columns['exclusion'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('inclusion_edit');
            
            $filterBuilder->addColumn(
                $columns['inclusion'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('zip_exclusion_edit');
            
            $filterBuilder->addColumn(
                $columns['zip_exclusion'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('zip_inclusion_edit');
            
            $filterBuilder->addColumn(
                $columns['zip_inclusion'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('cat_exclusion_edit');
            
            $filterBuilder->addColumn(
                $columns['cat_exclusion'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('cat_inclusion_edit');
            
            $filterBuilder->addColumn(
                $columns['cat_inclusion'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('quantity_edit');
            
            $filterBuilder->addColumn(
                $columns['quantity'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('origin_gln_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_tariff_edm_config_origin_gln_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('origin_gln', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_tariff_edm_config_origin_gln_search');
            
            $text_editor = new TextEdit('origin_gln');
            
            $filterBuilder->addColumn(
                $columns['origin_gln'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('disposition_gln_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_tariff_edm_config_disposition_gln_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('disposition_gln', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_tariff_edm_config_disposition_gln_search');
            
            $text_editor = new TextEdit('disposition_gln');
            
            $filterBuilder->addColumn(
                $columns['disposition_gln'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('quantity_percent_edit');
            
            $filterBuilder->addColumn(
                $columns['quantity_percent'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('remark');
            
            $filterBuilder->addColumn(
                $columns['remark'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('multiply_edit');
            
            $filterBuilder->addColumn(
                $columns['multiply'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('report_gln_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_tariff_edm_config_report_gln_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('report_gln', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_tariff_edm_config_report_gln_search');
            
            $text_editor = new TextEdit('report_gln');
            
            $filterBuilder->addColumn(
                $columns['report_gln'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
        }
    
        protected function AddOperationsColumns(Grid $grid)
        {
            $actions = $grid->getActions();
            $actions->setCaption($this->GetLocalizerCaptions()->GetMessageString('Actions'));
            $actions->setPosition(ActionList::POSITION_LEFT);
            
            if ($this->GetSecurityInfo()->HasViewGrant())
            {
                $operation = new AjaxOperation(OPERATION_VIEW,
                    $this->GetLocalizerCaptions()->GetMessageString('View'),
                    $this->GetLocalizerCaptions()->GetMessageString('View'), $this->dataset,
                    $this->GetModalGridViewHandler(), $grid);
                $operation->setUseImage(true);
                $actions->addOperation($operation);
            }
            
            if ($this->GetSecurityInfo()->HasEditGrant())
            {
                $operation = new AjaxOperation(OPERATION_EDIT,
                    $this->GetLocalizerCaptions()->GetMessageString('Edit'),
                    $this->GetLocalizerCaptions()->GetMessageString('Edit'), $this->dataset,
                    $this->GetGridEditHandler(), $grid);
                $operation->setUseImage(true);
                $actions->addOperation($operation);
                $operation->OnShow->AddListener('ShowEditButtonHandler', $this);
            }
            
            if ($this->GetSecurityInfo()->HasDeleteGrant())
            {
                $operation = new LinkOperation($this->GetLocalizerCaptions()->GetMessageString('Delete'), OPERATION_DELETE, $this->dataset, $grid);
                $operation->setUseImage(true);
                $actions->addOperation($operation);
                $operation->OnShow->AddListener('ShowDeleteButtonHandler', $this);
                $operation->SetAdditionalAttribute('data-modal-operation', 'delete');
                $operation->SetAdditionalAttribute('data-delete-handler-name', $this->GetModalGridDeleteHandler());
            }
        }
    
        protected function AddFieldColumns(Grid $grid, $withDetails = true)
        {
            //
            // View column for id field
            //
            $column = new TextViewColumn('id', 'id', 'ID', $this->dataset);
            $column->SetOrderable(true);
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Jahr', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_period_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_type', 'LA1', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA1_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for data_type field
            //
            $column = new TextViewColumn('data_type', 'data_type', 'Quelle', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_data_type_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA2', 'Abfallart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA2_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('tariff', 'LA3', 'Tarif', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA3_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for exclusion field
            //
            $column = new TextViewColumn('exclusion', 'exclusion', 'Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_exclusion_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for inclusion field
            //
            $column = new TextViewColumn('inclusion', 'inclusion', 'Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_inclusion_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for zip_exclusion field
            //
            $column = new TextViewColumn('zip_exclusion', 'zip_exclusion', 'PLZ Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_zip_exclusion_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for zip_inclusion field
            //
            $column = new TextViewColumn('zip_inclusion', 'zip_inclusion', 'PLZ Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_zip_inclusion_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for cat_exclusion field
            //
            $column = new TextViewColumn('cat_exclusion', 'cat_exclusion', 'CRM Typ Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_cat_exclusion_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for cat_inclusion field
            //
            $column = new TextViewColumn('cat_inclusion', 'cat_inclusion', 'CRM Typ Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_cat_inclusion_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for quantity field
            //
            $column = new NumberViewColumn('quantity', 'quantity', 'Masse', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(0);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_gln', 'LA4', 'Herkunft', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA4_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('disposition_gln', 'LA5', 'Verbleib', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA5_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for quantity_percent field
            //
            $column = new NumberViewColumn('quantity_percent', 'quantity_percent', 'Prozent Menge', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(2);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for remark field
            //
            $column = new TextViewColumn('remark', 'remark', 'Beschreibung', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_remark_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for multiply field
            //
            $column = new TextViewColumn('multiply', 'multiply', 'Multiply', $this->dataset);
            $column->SetOrderable(true);
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA6', 'Report GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA6_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
        }
    
        protected function AddSingleRecordViewColumns(Grid $grid)
        {
            //
            // View column for id field
            //
            $column = new TextViewColumn('id', 'id', 'ID', $this->dataset);
            $column->SetOrderable(true);
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Jahr', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_period_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_type', 'LA1', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA1_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for data_type field
            //
            $column = new TextViewColumn('data_type', 'data_type', 'Quelle', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_data_type_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA2', 'Abfallart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA2_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('tariff', 'LA3', 'Tarif', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA3_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for exclusion field
            //
            $column = new TextViewColumn('exclusion', 'exclusion', 'Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_exclusion_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for inclusion field
            //
            $column = new TextViewColumn('inclusion', 'inclusion', 'Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_inclusion_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for zip_exclusion field
            //
            $column = new TextViewColumn('zip_exclusion', 'zip_exclusion', 'PLZ Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_zip_exclusion_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for zip_inclusion field
            //
            $column = new TextViewColumn('zip_inclusion', 'zip_inclusion', 'PLZ Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_zip_inclusion_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for cat_exclusion field
            //
            $column = new TextViewColumn('cat_exclusion', 'cat_exclusion', 'CRM Typ Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_cat_exclusion_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for cat_inclusion field
            //
            $column = new TextViewColumn('cat_inclusion', 'cat_inclusion', 'CRM Typ Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_cat_inclusion_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for quantity field
            //
            $column = new NumberViewColumn('quantity', 'quantity', 'Masse', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(0);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_gln', 'LA4', 'Herkunft', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA4_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('disposition_gln', 'LA5', 'Verbleib', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA5_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for quantity_percent field
            //
            $column = new NumberViewColumn('quantity_percent', 'quantity_percent', 'Prozent Menge', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(2);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for remark field
            //
            $column = new TextViewColumn('remark', 'remark', 'Beschreibung', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_remark_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for multiply field
            //
            $column = new TextViewColumn('multiply', 'multiply', 'Multiplikator', $this->dataset);
            $column->SetOrderable(true);
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA6', 'Report GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA6_handler_view');
            $grid->AddSingleRecordViewColumn($column);
        }
    
        protected function AddEditColumns(Grid $grid)
        {
            //
            // Edit column for id field
            //
            $editor = new TextEdit('id_edit');
            $editColumn = new CustomEditColumn('ID', 'id', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for period field
            //
            $editor = new TextEdit('period_edit');
            $editColumn = new CustomEditColumn('Jahr', 'period', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for action_type field
            //
            $editor = new ComboBox('action_type_edit', $this->GetLocalizerCaptions()->GetMessageString('PleaseSelect'));
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_activity_types"');
            $lookupDataset->addFields(
                array(
                    new StringField('activity_type', true, true),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new LookUpEditColumn(
                'Typ', 
                'action_type', 
                $editor, 
                $this->dataset, 'activity_type', 'description', $lookupDataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for data_type field
            //
            $editor = new ComboBox('data_type_edit', $this->GetLocalizerCaptions()->GetMessageString('PleaseSelect'));
            $editor->addChoice('ls', 'Lieferschein');
            $editor->addChoice('manuell', 'Manuell');
            $editColumn = new CustomEditColumn('Quelle', 'data_type', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for waste_gtin field
            //
            $editor = new DynamicCombobox('waste_gtin_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Abfallart', 'waste_gtin', 'LA2', 'edit_public_tariff_edm_config_waste_gtin_search', $editor, $this->dataset, $lookupDataset, 'gtin', 'selector', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for tariff field
            //
            $editor = new DynamicCombobox('tariff_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qtariff_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('id'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Tarif', 'tariff', 'LA3', 'edit_public_tariff_edm_config_tariff_search', $editor, $this->dataset, $lookupDataset, 'id', 'selector', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for exclusion field
            //
            $editor = new TextEdit('exclusion_edit');
            $editColumn = new CustomEditColumn('Ausschluss', 'exclusion', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for inclusion field
            //
            $editor = new TextEdit('inclusion_edit');
            $editColumn = new CustomEditColumn('Einschluss', 'inclusion', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for zip_exclusion field
            //
            $editor = new TextEdit('zip_exclusion_edit');
            $editColumn = new CustomEditColumn('PLZ Ausschluss', 'zip_exclusion', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for zip_inclusion field
            //
            $editor = new TextEdit('zip_inclusion_edit');
            $editColumn = new CustomEditColumn('PLZ Einschluss', 'zip_inclusion', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for cat_exclusion field
            //
            $editor = new TextEdit('cat_exclusion_edit');
            $editColumn = new CustomEditColumn('CRM Typ Ausschluss', 'cat_exclusion', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for cat_inclusion field
            //
            $editor = new TextEdit('cat_inclusion_edit');
            $editColumn = new CustomEditColumn('CRM Typ Einschluss', 'cat_inclusion', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for quantity field
            //
            $editor = new TextEdit('quantity_edit');
            $editColumn = new CustomEditColumn('Masse', 'quantity', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $validator = new NumberValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('NumberValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for origin_gln field
            //
            $editor = new DynamicCombobox('origin_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qgln_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln'),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Herkunft', 'origin_gln', 'LA4', 'edit_public_tariff_edm_config_origin_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for disposition_gln field
            //
            $editor = new DynamicCombobox('disposition_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qgln_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln'),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Verbleib', 'disposition_gln', 'LA5', 'edit_public_tariff_edm_config_disposition_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for quantity_percent field
            //
            $editor = new TextEdit('quantity_percent_edit');
            $editColumn = new CustomEditColumn('Prozent Menge', 'quantity_percent', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $validator = new MaxValueValidator(100, StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('MaxValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $validator = new MinValueValidator(0, StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('MinValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $validator = new NumberValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('NumberValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for remark field
            //
            $editor = new TextAreaEdit('remark_edit', 50, 8);
            $editColumn = new CustomEditColumn('Beschreibung', 'remark', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for multiply field
            //
            $editor = new TextEdit('multiply_edit');
            $editColumn = new CustomEditColumn('Multiplikator', 'multiply', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for report_gln field
            //
            $editor = new DynamicCombobox('report_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Report GLN', 'report_gln', 'LA6', 'edit_public_tariff_edm_config_report_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
        }
    
        protected function AddMultiEditColumns(Grid $grid)
        {
            //
            // Edit column for period field
            //
            $editor = new TextEdit('period_edit');
            $editColumn = new CustomEditColumn('Jahr', 'period', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for action_type field
            //
            $editor = new ComboBox('action_type_edit', $this->GetLocalizerCaptions()->GetMessageString('PleaseSelect'));
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_activity_types"');
            $lookupDataset->addFields(
                array(
                    new StringField('activity_type', true, true),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new LookUpEditColumn(
                'Typ', 
                'action_type', 
                $editor, 
                $this->dataset, 'activity_type', 'description', $lookupDataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for data_type field
            //
            $editor = new ComboBox('data_type_edit', $this->GetLocalizerCaptions()->GetMessageString('PleaseSelect'));
            $editor->addChoice('ls', 'Lieferschein');
            $editor->addChoice('manuell', 'Manuell');
            $editColumn = new CustomEditColumn('Quelle', 'data_type', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for waste_gtin field
            //
            $editor = new DynamicCombobox('waste_gtin_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Abfallart', 'waste_gtin', 'LA2', 'multi_edit_public_tariff_edm_config_waste_gtin_search', $editor, $this->dataset, $lookupDataset, 'gtin', 'selector', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for tariff field
            //
            $editor = new DynamicCombobox('tariff_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qtariff_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('id'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Tarif', 'tariff', 'LA3', 'multi_edit_public_tariff_edm_config_tariff_search', $editor, $this->dataset, $lookupDataset, 'id', 'selector', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for exclusion field
            //
            $editor = new TextEdit('exclusion_edit');
            $editColumn = new CustomEditColumn('Ausschluss', 'exclusion', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for inclusion field
            //
            $editor = new TextEdit('inclusion_edit');
            $editColumn = new CustomEditColumn('Einschluss', 'inclusion', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for zip_exclusion field
            //
            $editor = new TextEdit('zip_exclusion_edit');
            $editColumn = new CustomEditColumn('PLZ Ausschluss', 'zip_exclusion', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for zip_inclusion field
            //
            $editor = new TextEdit('zip_inclusion_edit');
            $editColumn = new CustomEditColumn('PLZ Einschluss', 'zip_inclusion', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for cat_exclusion field
            //
            $editor = new TextEdit('cat_exclusion_edit');
            $editColumn = new CustomEditColumn('CRM Typ Ausschluss', 'cat_exclusion', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for cat_inclusion field
            //
            $editor = new TextEdit('cat_inclusion_edit');
            $editColumn = new CustomEditColumn('CRM Typ Einschluss', 'cat_inclusion', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for quantity field
            //
            $editor = new TextEdit('quantity_edit');
            $editColumn = new CustomEditColumn('Masse', 'quantity', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $validator = new NumberValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('NumberValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for origin_gln field
            //
            $editor = new DynamicCombobox('origin_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qgln_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln'),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Herkunft', 'origin_gln', 'LA4', 'multi_edit_public_tariff_edm_config_origin_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for disposition_gln field
            //
            $editor = new DynamicCombobox('disposition_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qgln_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln'),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Verbleib', 'disposition_gln', 'LA5', 'multi_edit_public_tariff_edm_config_disposition_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for quantity_percent field
            //
            $editor = new TextEdit('quantity_percent_edit');
            $editColumn = new CustomEditColumn('Prozent Menge', 'quantity_percent', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $validator = new MaxValueValidator(100, StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('MaxValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $validator = new MinValueValidator(0, StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('MinValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $validator = new NumberValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('NumberValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for remark field
            //
            $editor = new TextAreaEdit('remark_edit', 50, 8);
            $editColumn = new CustomEditColumn('Beschreibung', 'remark', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for multiply field
            //
            $editor = new TextEdit('multiply_edit');
            $editColumn = new CustomEditColumn('Multiply', 'multiply', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for report_gln field
            //
            $editor = new DynamicCombobox('report_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Report GLN', 'report_gln', 'LA6', 'multi_edit_public_tariff_edm_config_report_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
        }
    
        protected function AddInsertColumns(Grid $grid)
        {
            //
            // Edit column for id field
            //
            $editor = new TextEdit('id_edit');
            $editColumn = new CustomEditColumn('ID', 'id', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for period field
            //
            $editor = new TextEdit('period_edit');
            $editColumn = new CustomEditColumn('Jahr', 'period', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for action_type field
            //
            $editor = new ComboBox('action_type_edit', $this->GetLocalizerCaptions()->GetMessageString('PleaseSelect'));
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_activity_types"');
            $lookupDataset->addFields(
                array(
                    new StringField('activity_type', true, true),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new LookUpEditColumn(
                'Typ', 
                'action_type', 
                $editor, 
                $this->dataset, 'activity_type', 'description', $lookupDataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for data_type field
            //
            $editor = new ComboBox('data_type_edit', $this->GetLocalizerCaptions()->GetMessageString('PleaseSelect'));
            $editor->addChoice('ls', 'Lieferschein');
            $editor->addChoice('manuell', 'Manuell');
            $editColumn = new CustomEditColumn('Quelle', 'data_type', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for waste_gtin field
            //
            $editor = new DynamicCombobox('waste_gtin_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Abfallart', 'waste_gtin', 'LA2', 'insert_public_tariff_edm_config_waste_gtin_search', $editor, $this->dataset, $lookupDataset, 'gtin', 'selector', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for tariff field
            //
            $editor = new DynamicCombobox('tariff_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qtariff_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('id'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Tarif', 'tariff', 'LA3', 'insert_public_tariff_edm_config_tariff_search', $editor, $this->dataset, $lookupDataset, 'id', 'selector', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for exclusion field
            //
            $editor = new TextEdit('exclusion_edit');
            $editColumn = new CustomEditColumn('Ausschluss', 'exclusion', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for inclusion field
            //
            $editor = new TextEdit('inclusion_edit');
            $editColumn = new CustomEditColumn('Einschluss', 'inclusion', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for zip_exclusion field
            //
            $editor = new TextEdit('zip_exclusion_edit');
            $editColumn = new CustomEditColumn('PLZ Ausschluss', 'zip_exclusion', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for zip_inclusion field
            //
            $editor = new TextEdit('zip_inclusion_edit');
            $editColumn = new CustomEditColumn('PLZ Einschluss', 'zip_inclusion', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for cat_exclusion field
            //
            $editor = new TextEdit('cat_exclusion_edit');
            $editColumn = new CustomEditColumn('CRM Typ Ausschluss', 'cat_exclusion', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for cat_inclusion field
            //
            $editor = new TextEdit('cat_inclusion_edit');
            $editColumn = new CustomEditColumn('CRM Typ Einschluss', 'cat_inclusion', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for quantity field
            //
            $editor = new TextEdit('quantity_edit');
            $editColumn = new CustomEditColumn('Masse', 'quantity', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $validator = new NumberValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('NumberValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for origin_gln field
            //
            $editor = new DynamicCombobox('origin_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qgln_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln'),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Herkunft', 'origin_gln', 'LA4', 'insert_public_tariff_edm_config_origin_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for disposition_gln field
            //
            $editor = new DynamicCombobox('disposition_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qgln_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln'),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Verbleib', 'disposition_gln', 'LA5', 'insert_public_tariff_edm_config_disposition_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for quantity_percent field
            //
            $editor = new TextEdit('quantity_percent_edit');
            $editColumn = new CustomEditColumn('Prozent Menge', 'quantity_percent', $editor, $this->dataset);
            $editColumn->SetInsertDefaultValue('100');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $validator = new MaxValueValidator(100, StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('MaxValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $validator = new MinValueValidator(0, StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('MinValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $validator = new NumberValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('NumberValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for remark field
            //
            $editor = new TextAreaEdit('remark_edit', 50, 8);
            $editColumn = new CustomEditColumn('Beschreibung', 'remark', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for multiply field
            //
            $editor = new TextEdit('multiply_edit');
            $editColumn = new CustomEditColumn('Multiplikator', 'multiply', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for report_gln field
            //
            $editor = new DynamicCombobox('report_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Report GLN', 'report_gln', 'LA6', 'insert_public_tariff_edm_config_report_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            $grid->SetShowAddButton(true && $this->GetSecurityInfo()->HasAddGrant());
        }
    
        private function AddMultiUploadColumn(Grid $grid)
        {
    
        }
    
        protected function AddPrintColumns(Grid $grid)
        {
            //
            // View column for id field
            //
            $column = new TextViewColumn('id', 'id', 'ID', $this->dataset);
            $column->SetOrderable(true);
            $grid->AddPrintColumn($column);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Period', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_period_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_type', 'LA1', 'Action Type', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA1_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for data_type field
            //
            $column = new TextViewColumn('data_type', 'data_type', 'Data Type', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_data_type_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA2', 'Waste Gtin', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA2_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('tariff', 'LA3', 'Tariff', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA3_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for exclusion field
            //
            $column = new TextViewColumn('exclusion', 'exclusion', 'Exclusion', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_exclusion_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for inclusion field
            //
            $column = new TextViewColumn('inclusion', 'inclusion', 'Inclusion', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_inclusion_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for zip_exclusion field
            //
            $column = new TextViewColumn('zip_exclusion', 'zip_exclusion', 'PLZ Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_zip_exclusion_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for zip_inclusion field
            //
            $column = new TextViewColumn('zip_inclusion', 'zip_inclusion', 'PLZ Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_zip_inclusion_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for cat_exclusion field
            //
            $column = new TextViewColumn('cat_exclusion', 'cat_exclusion', 'CRM Typ Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_cat_exclusion_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for cat_inclusion field
            //
            $column = new TextViewColumn('cat_inclusion', 'cat_inclusion', 'CRM Typ Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_cat_inclusion_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for quantity field
            //
            $column = new NumberViewColumn('quantity', 'quantity', 'Masse', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(0);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddPrintColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_gln', 'LA4', 'Origin Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA4_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('disposition_gln', 'LA5', 'Disposition Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA5_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for quantity_percent field
            //
            $column = new NumberViewColumn('quantity_percent', 'quantity_percent', 'Prozent Menge', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(2);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddPrintColumn($column);
            
            //
            // View column for remark field
            //
            $column = new TextViewColumn('remark', 'remark', 'Beschreibung', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_remark_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for multiply field
            //
            $column = new TextViewColumn('multiply', 'multiply', 'Multiplikator', $this->dataset);
            $column->SetOrderable(true);
            $grid->AddPrintColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA6', 'Report Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA6_handler_print');
            $grid->AddPrintColumn($column);
        }
    
        protected function AddExportColumns(Grid $grid)
        {
            //
            // View column for id field
            //
            $column = new TextViewColumn('id', 'id', 'ID', $this->dataset);
            $column->SetOrderable(true);
            $grid->AddExportColumn($column);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Period', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_period_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_type', 'LA1', 'Action Type', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA1_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for data_type field
            //
            $column = new TextViewColumn('data_type', 'data_type', 'Data Type', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_data_type_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA2', 'Waste Gtin', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA2_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('tariff', 'LA3', 'Tariff', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA3_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for exclusion field
            //
            $column = new TextViewColumn('exclusion', 'exclusion', 'Exclusion', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_exclusion_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for inclusion field
            //
            $column = new TextViewColumn('inclusion', 'inclusion', 'Inclusion', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_inclusion_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for zip_exclusion field
            //
            $column = new TextViewColumn('zip_exclusion', 'zip_exclusion', 'PLZ Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_zip_exclusion_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for zip_inclusion field
            //
            $column = new TextViewColumn('zip_inclusion', 'zip_inclusion', 'PLZ Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_zip_inclusion_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for cat_exclusion field
            //
            $column = new TextViewColumn('cat_exclusion', 'cat_exclusion', 'CRM Typ Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_cat_exclusion_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for cat_inclusion field
            //
            $column = new TextViewColumn('cat_inclusion', 'cat_inclusion', 'CRM Typ Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_cat_inclusion_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for quantity field
            //
            $column = new NumberViewColumn('quantity', 'quantity', 'Masse', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(0);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddExportColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_gln', 'LA4', 'Origin Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA4_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('disposition_gln', 'LA5', 'Disposition Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA5_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for quantity_percent field
            //
            $column = new NumberViewColumn('quantity_percent', 'quantity_percent', 'Prozent Menge', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(2);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddExportColumn($column);
            
            //
            // View column for remark field
            //
            $column = new TextViewColumn('remark', 'remark', 'Beschreibung', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_remark_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for multiply field
            //
            $column = new TextViewColumn('multiply', 'multiply', 'Multiplikator', $this->dataset);
            $column->SetOrderable(true);
            $grid->AddExportColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA6', 'Report Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA6_handler_export');
            $grid->AddExportColumn($column);
        }
    
        private function AddCompareColumns(Grid $grid)
        {
            //
            // View column for id field
            //
            $column = new TextViewColumn('id', 'id', 'ID', $this->dataset);
            $column->SetOrderable(true);
            $grid->AddCompareColumn($column);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Jahr', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_period_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_type', 'LA1', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA1_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for data_type field
            //
            $column = new TextViewColumn('data_type', 'data_type', 'Quelle', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_data_type_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA2', 'Abfallart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA2_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('tariff', 'LA3', 'Tarif', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA3_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for exclusion field
            //
            $column = new TextViewColumn('exclusion', 'exclusion', 'Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_exclusion_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for inclusion field
            //
            $column = new TextViewColumn('inclusion', 'inclusion', 'Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_inclusion_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for zip_exclusion field
            //
            $column = new TextViewColumn('zip_exclusion', 'zip_exclusion', 'PLZ Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_zip_exclusion_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for zip_inclusion field
            //
            $column = new TextViewColumn('zip_inclusion', 'zip_inclusion', 'PLZ Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_zip_inclusion_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for cat_exclusion field
            //
            $column = new TextViewColumn('cat_exclusion', 'cat_exclusion', 'CRM Typ Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_cat_exclusion_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for cat_inclusion field
            //
            $column = new TextViewColumn('cat_inclusion', 'cat_inclusion', 'CRM Typ Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_cat_inclusion_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for quantity field
            //
            $column = new NumberViewColumn('quantity', 'quantity', 'Masse', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(0);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddCompareColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_gln', 'LA4', 'Herkunft', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA4_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('disposition_gln', 'LA5', 'Verbleib', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA5_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for quantity_percent field
            //
            $column = new NumberViewColumn('quantity_percent', 'quantity_percent', 'Prozent Menge', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(2);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddCompareColumn($column);
            
            //
            // View column for remark field
            //
            $column = new TextViewColumn('remark', 'remark', 'Beschreibung', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_remark_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for multiply field
            //
            $column = new TextViewColumn('multiply', 'multiply', 'Multiply', $this->dataset);
            $column->SetOrderable(true);
            $grid->AddCompareColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA6', 'Report GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_tariff_edm_configGrid_LA6_handler_compare');
            $grid->AddCompareColumn($column);
        }
    
        private function AddCompareHeaderColumns(Grid $grid)
        {
    
        }
    
        public function GetPageDirection()
        {
            return null;
        }
    
        public function isFilterConditionRequired()
        {
            return true;
        }
    
        protected function ApplyCommonColumnEditProperties(CustomEditColumn $column)
        {
            $column->SetDisplaySetToNullCheckBox(false);
            $column->SetDisplaySetToDefaultCheckBox(false);
    		$column->SetVariableContainer($this->GetColumnVariableContainer());
        }
    
        function GetCustomClientScript()
        {
            return ;
        }
        
        function GetOnPageLoadedClientScript()
        {
            return ;
        }
        
        public function GetEnableModalGridInsert() { return true; }
        public function GetEnableModalSingleRecordView() { return true; }
        
        public function GetEnableModalGridEdit() { return true; }
        
        protected function GetEnableModalGridDelete() { return true; }
    
        protected function CreateGrid()
        {
            $result = new Grid($this, $this->dataset);
            if ($this->GetSecurityInfo()->HasDeleteGrant())
               $result->SetAllowDeleteSelected(false);
            else
               $result->SetAllowDeleteSelected(false);   
            
            ApplyCommonPageSettings($this, $result);
            
            $result->SetUseImagesForActions(true);
            $defaultSortedColumns = array();
            $defaultSortedColumns[] = new SortColumn('period', 'DESC');
            $defaultSortedColumns[] = new SortColumn('id', 'ASC');
            $result->setDefaultOrdering($defaultSortedColumns);
            $result->SetUseFixedHeader(false);
            $result->SetShowLineNumbers(false);
            $result->SetViewMode(ViewMode::TABLE);
            $result->setEnableRuntimeCustomization(true);
            $result->setAllowCompare(true);
            $this->AddCompareHeaderColumns($result);
            $this->AddCompareColumns($result);
            $result->setMultiEditAllowed($this->GetSecurityInfo()->HasEditGrant() && false);
            $result->setTableBordered(false);
            $result->setTableCondensed(false);
            
            $result->SetHighlightRowAtHover(false);
            $result->SetWidth('');
            $this->AddOperationsColumns($result);
            $this->AddFieldColumns($result);
            $this->AddSingleRecordViewColumns($result);
            $this->AddEditColumns($result);
            $this->AddMultiEditColumns($result);
            $this->AddInsertColumns($result);
            $this->AddPrintColumns($result);
            $this->AddExportColumns($result);
            $this->AddMultiUploadColumn($result);
    
    
            $this->SetShowPageList(true);
            $this->SetShowTopPageNavigator(true);
            $this->SetShowBottomPageNavigator(false);
            $this->setPrintListAvailable(true);
            $this->setPrintListRecordAvailable(false);
            $this->setPrintOneRecordAvailable(true);
            $this->setAllowPrintSelectedRecords(true);
            $this->setExportListAvailable(array('pdf', 'excel', 'word', 'xml', 'csv'));
            $this->setExportSelectedRecordsAvailable(array('pdf', 'excel', 'word', 'xml', 'csv'));
            $this->setExportListRecordAvailable(array());
            $this->setExportOneRecordAvailable(array('pdf', 'excel', 'word', 'xml', 'csv'));
    
            return $result;
        }
     
        protected function setClientSideEvents(Grid $grid) {
    
        }
    
        protected function doRegisterHandlers() {
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Jahr', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_period_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_type', 'LA1', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA1_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for data_type field
            //
            $column = new TextViewColumn('data_type', 'data_type', 'Quelle', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_data_type_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA2', 'Abfallart', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA2_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('tariff', 'LA3', 'Tarif', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA3_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for exclusion field
            //
            $column = new TextViewColumn('exclusion', 'exclusion', 'Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_exclusion_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for inclusion field
            //
            $column = new TextViewColumn('inclusion', 'inclusion', 'Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_inclusion_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for zip_exclusion field
            //
            $column = new TextViewColumn('zip_exclusion', 'zip_exclusion', 'PLZ Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_zip_exclusion_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for zip_inclusion field
            //
            $column = new TextViewColumn('zip_inclusion', 'zip_inclusion', 'PLZ Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_zip_inclusion_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for cat_exclusion field
            //
            $column = new TextViewColumn('cat_exclusion', 'cat_exclusion', 'CRM Typ Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_cat_exclusion_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for cat_inclusion field
            //
            $column = new TextViewColumn('cat_inclusion', 'cat_inclusion', 'CRM Typ Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_cat_inclusion_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_gln', 'LA4', 'Herkunft', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA4_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('disposition_gln', 'LA5', 'Verbleib', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA5_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for remark field
            //
            $column = new TextViewColumn('remark', 'remark', 'Beschreibung', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_remark_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA6', 'Report GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA6_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Period', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_period_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_type', 'LA1', 'Action Type', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA1_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for data_type field
            //
            $column = new TextViewColumn('data_type', 'data_type', 'Data Type', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_data_type_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA2', 'Waste Gtin', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA2_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('tariff', 'LA3', 'Tariff', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA3_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for exclusion field
            //
            $column = new TextViewColumn('exclusion', 'exclusion', 'Exclusion', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_exclusion_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for inclusion field
            //
            $column = new TextViewColumn('inclusion', 'inclusion', 'Inclusion', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_inclusion_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for zip_exclusion field
            //
            $column = new TextViewColumn('zip_exclusion', 'zip_exclusion', 'PLZ Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_zip_exclusion_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for zip_inclusion field
            //
            $column = new TextViewColumn('zip_inclusion', 'zip_inclusion', 'PLZ Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_zip_inclusion_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for cat_exclusion field
            //
            $column = new TextViewColumn('cat_exclusion', 'cat_exclusion', 'CRM Typ Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_cat_exclusion_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for cat_inclusion field
            //
            $column = new TextViewColumn('cat_inclusion', 'cat_inclusion', 'CRM Typ Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_cat_inclusion_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_gln', 'LA4', 'Origin Gln', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA4_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('disposition_gln', 'LA5', 'Disposition Gln', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA5_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for remark field
            //
            $column = new TextViewColumn('remark', 'remark', 'Beschreibung', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_remark_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA6', 'Report Gln', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA6_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Jahr', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_period_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_type', 'LA1', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA1_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for data_type field
            //
            $column = new TextViewColumn('data_type', 'data_type', 'Quelle', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_data_type_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA2', 'Abfallart', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA2_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('tariff', 'LA3', 'Tarif', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA3_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for exclusion field
            //
            $column = new TextViewColumn('exclusion', 'exclusion', 'Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_exclusion_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for inclusion field
            //
            $column = new TextViewColumn('inclusion', 'inclusion', 'Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_inclusion_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for zip_exclusion field
            //
            $column = new TextViewColumn('zip_exclusion', 'zip_exclusion', 'PLZ Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_zip_exclusion_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for zip_inclusion field
            //
            $column = new TextViewColumn('zip_inclusion', 'zip_inclusion', 'PLZ Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_zip_inclusion_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for cat_exclusion field
            //
            $column = new TextViewColumn('cat_exclusion', 'cat_exclusion', 'CRM Typ Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_cat_exclusion_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for cat_inclusion field
            //
            $column = new TextViewColumn('cat_inclusion', 'cat_inclusion', 'CRM Typ Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_cat_inclusion_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_gln', 'LA4', 'Herkunft', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA4_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('disposition_gln', 'LA5', 'Verbleib', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA5_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for remark field
            //
            $column = new TextViewColumn('remark', 'remark', 'Beschreibung', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_remark_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA6', 'Report GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA6_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_tariff_edm_config_waste_gtin_search', 'gtin', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qtariff_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('id'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_tariff_edm_config_tariff_search', 'id', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qgln_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln'),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_tariff_edm_config_origin_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qgln_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln'),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_tariff_edm_config_disposition_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_tariff_edm_config_report_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_activity_types"');
            $lookupDataset->addFields(
                array(
                    new StringField('activity_type', true, true),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_tariff_edm_config_action_type_search', 'activity_type', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_tariff_edm_config_waste_gtin_search', 'gtin', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qtariff_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('id'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_tariff_edm_config_tariff_search', 'id', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qgln_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln'),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_tariff_edm_config_origin_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qgln_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln'),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_tariff_edm_config_disposition_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_tariff_edm_config_report_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Jahr', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_period_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_type', 'LA1', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA1_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for data_type field
            //
            $column = new TextViewColumn('data_type', 'data_type', 'Quelle', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_data_type_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA2', 'Abfallart', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA2_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('tariff', 'LA3', 'Tarif', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA3_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for exclusion field
            //
            $column = new TextViewColumn('exclusion', 'exclusion', 'Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_exclusion_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for inclusion field
            //
            $column = new TextViewColumn('inclusion', 'inclusion', 'Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_inclusion_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for zip_exclusion field
            //
            $column = new TextViewColumn('zip_exclusion', 'zip_exclusion', 'PLZ Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_zip_exclusion_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for zip_inclusion field
            //
            $column = new TextViewColumn('zip_inclusion', 'zip_inclusion', 'PLZ Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_zip_inclusion_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for cat_exclusion field
            //
            $column = new TextViewColumn('cat_exclusion', 'cat_exclusion', 'CRM Typ Ausschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_cat_exclusion_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for cat_inclusion field
            //
            $column = new TextViewColumn('cat_inclusion', 'cat_inclusion', 'CRM Typ Einschluss', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_cat_inclusion_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_gln', 'LA4', 'Herkunft', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA4_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('disposition_gln', 'LA5', 'Verbleib', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA5_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for remark field
            //
            $column = new TextViewColumn('remark', 'remark', 'Beschreibung', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_remark_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA6', 'Report GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_tariff_edm_configGrid_LA6_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_tariff_edm_config_waste_gtin_search', 'gtin', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qtariff_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('id'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_tariff_edm_config_tariff_search', 'id', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qgln_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln'),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_tariff_edm_config_origin_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qgln_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln'),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_tariff_edm_config_disposition_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_tariff_edm_config_report_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'multi_edit_public_tariff_edm_config_waste_gtin_search', 'gtin', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qtariff_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('id'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'multi_edit_public_tariff_edm_config_tariff_search', 'id', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qgln_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln'),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'multi_edit_public_tariff_edm_config_origin_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qgln_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln'),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'multi_edit_public_tariff_edm_config_disposition_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'multi_edit_public_tariff_edm_config_report_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
        }
       
        protected function doCustomRenderColumn($fieldName, $fieldData, $rowData, &$customText, &$handled)
        { 
    
        }
    
        protected function doCustomRenderPrintColumn($fieldName, $fieldData, $rowData, &$customText, &$handled)
        { 
    
        }
    
        protected function doCustomRenderExportColumn($exportType, $fieldName, $fieldData, $rowData, &$customText, &$handled)
        { 
    
        }
    
        protected function doCustomDrawRow($rowData, &$cellFontColor, &$cellFontSize, &$cellBgColor, &$cellItalicAttr, &$cellBoldAttr)
        {
    
        }
    
        protected function doExtendedCustomDrawRow($rowData, &$rowCellStyles, &$rowStyles, &$rowClasses, &$cellClasses)
        {
    
        }
    
        protected function doCustomRenderTotal($totalValue, $aggregate, $columnName, &$customText, &$handled)
        {
    
        }
    
        protected function doCustomDefaultValues(&$values, &$handled) 
        {
    
        }
    
        protected function doCustomCompareColumn($columnName, $valueA, $valueB, &$result)
        {
    
        }
    
        protected function doBeforeInsertRecord($page, &$rowData, $tableName, &$cancel, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doBeforeUpdateRecord($page, $oldRowData, &$rowData, $tableName, &$cancel, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doBeforeDeleteRecord($page, &$rowData, $tableName, &$cancel, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doAfterInsertRecord($page, $rowData, $tableName, &$success, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doAfterUpdateRecord($page, $oldRowData, $rowData, $tableName, &$success, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doAfterDeleteRecord($page, $rowData, $tableName, &$success, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doCustomHTMLHeader($page, &$customHtmlHeaderText)
        { 
    
        }
    
        protected function doGetCustomTemplate($type, $part, $mode, &$result, &$params)
        {
    
        }
    
        protected function doGetCustomExportOptions(Page $page, $exportType, $rowData, &$options)
        {
    
        }
    
        protected function doFileUpload($fieldName, $rowData, &$result, &$accept, $originalFileName, $originalFileExtension, $fileSize, $tempFileName)
        {
    
        }
    
        protected function doPrepareChart(Chart $chart)
        {
    
        }
    
        protected function doPrepareColumnFilter(ColumnFilter $columnFilter)
        {
    
        }
    
        protected function doPrepareFilterBuilder(FilterBuilder $filterBuilder, FixedKeysArray $columns)
        {
    
        }
    
        protected function doGetSelectionFilters(FixedKeysArray $columns, &$result)
        {
    
        }
    
        protected function doGetCustomFormLayout($mode, FixedKeysArray $columns, FormLayout $layout)
        {
    
        }
    
        protected function doGetCustomColumnGroup(FixedKeysArray $columns, ViewColumnGroup $columnGroup)
        {
    
        }
    
        protected function doPageLoaded()
        {
    
        }
    
        protected function doCalculateFields($rowData, $fieldName, &$value)
        {
    
        }
    
        protected function doGetCustomPagePermissions(Page $page, PermissionSet &$permissions, &$handled)
        {
    
        }
    
        protected function doGetCustomRecordPermissions(Page $page, &$usingCondition, $rowData, &$allowEdit, &$allowDelete, &$mergeWithDefault, &$handled)
        {
    
        }
    
    }

    SetUpUserAuthorization();

    try
    {
        $Page = new public_tariff_edm_configPage("public_tariff_edm_config", "frmTariff_edm_config.php", GetCurrentUserPermissionSetForDataSource("public.tariff_edm_config"), 'UTF-8');
        $Page->SetRecordPermission(GetCurrentUserRecordPermissionsForDataSource("public.tariff_edm_config"));
        GetApplication()->SetMainPage($Page);
        GetApplication()->Run();
    }
    catch(Exception $e)
    {
        ShowErrorPage($e);
    }
	
