<?php
    include_once dirname(__FILE__) . '/../components/application.php';
    if (GetApplication()->GetCurrentUserId() == null)
    {
        header('Location: ../login.php');
        exit;
    }
?>

<?php

//error_reporting(0);

function bmd_sftp_upload ($fnam, $fpath)
{

    $ret = true;

    $query_ftp_server = "select field from preset where section = 'bmd' and param = 'ftp_server'";
    $query_ftp_user = "select field from preset where section = 'bmd' and param = 'ftp_user'";
    $query_ftp_pass = "select field from preset where section = 'bmd' and param = 'ftp_pass'";
    $query_ftp_test = "select field from preset where section = 'bmd' and param = 'ftp_test'";

    $result_ftp_server = pg_query($query_ftp_server);
    if (!$result_ftp_server)
    {
        echo "Problem with query " . $query_ftp_server . "<br/>";
        echo pg_last_error();
        exit();
    }

    $result_ftp_user = pg_query($query_ftp_user);
    if (!$result_ftp_user)
    {
        echo "Problem with query " . $result_ftp_user . "<br/>";
        echo pg_last_error();
        exit();
    }

    $result_ftp_pass = pg_query($query_ftp_pass);
    if (!$result_ftp_pass)
    {
        echo "Problem with query " . $result_ftp_pass . "<br/>";
        echo pg_last_error();
        exit();
    }

    $result_ftp_test = pg_query($query_ftp_test);
    if (!$result_ftp_test)
    {
        echo "Problem with query " . $result_ftp_test . "<br/>";
        echo pg_last_error();
        exit();
    }

    $row = pg_fetch_assoc($result_ftp_server);
    $ftp_server = $row['field'];

    $row = pg_fetch_assoc($result_ftp_user);
    $ftp_user = $row['field'];

    $row = pg_fetch_assoc($result_ftp_pass);
    $ftp_pass = $row['field'];

    $row = pg_fetch_assoc($result_ftp_test);
    $ftp_test = $row['field'];

    if ($ftp_server === '' or $ftp_user === '' or $ftp_pass === '' or $ftp_test === '')
    {
        $ret = false;
        echo 'FTP Konfiguration fehlt!<br>';
    }
    else
    {

        if ($ftp_test === 'no')
        {
            // PRODUCTION
            $ftp_path = '/' . date("Y") . '/AR Import/';
        }
        else
        {
            // TEST
            $ftp_path = '/Testimport/Testimport AR/';
        }

        $ftp = ftp_ssl_connect($ftp_server);
        if (ftp_login($ftp, $ftp_user, $ftp_pass))
        {
            ftp_pasv($ftp, true);

            $fdir = ftp_nlist($ftp, $ftp_path);

            if (in_array($ftp_path . $fnam, $fdir))
            {
                echo 'Datei ' . $ftp_path . $fnam . ' bereits vorhanden ...<br>';
            }
            else
            {
                if (ftp_chdir($ftp, $ftp_path))
                {
                    if (!ftp_put($ftp, $fnam, $fpath . '/' . $fnam, FTP_BINARY))
                    {
                        $ret = false;
                    }
                } else
                {
                    $ret = false;
                }
            }
            ftp_close($ftp);
        } else
        {
            $ret = false;
        }

    }

    return $ret;

}

echo 'Starte PDF Erstellung<br>';

$max_docs = 100000;

$sql = "select field from preset where section = 'report' and param = 'print_invoice_batch_report'";
$res = pg_query($sql);
$row = pg_fetch_assoc($res);
$repname = $row["field"];

$sql = 'select * from report where report_name=\''.$repname.'\'';
$res = pg_query($sql);
$rep = pg_fetch_array($res);

$i = 0;

$query_data = "select 
					i.year, 
					i.nr 
				from 
					invoice i 
                where
                    not exported and printed
				order by 
					year, nr";

$result_data = pg_query($query_data);

if (!$result_data)
{
	echo "Problem with query " . $result_data . "<br/>";
	echo pg_last_error();
	exit();
}

while($row = pg_fetch_assoc($result_data) and $i < $max_docs)
{

	$tstamp = 'mcapdf_'.date('ymj_his_');

	if (substr($_SERVER['DOCUMENT_ROOT'],0,1) == '/')
	{
		$str = 'xvfb-run -a rptrender ';
	}
	else
	{
		$str = '"rptrender" ';
	}

	$str = $str."-databaseURL=\"pgsql://".GetGlobalConnectionOptions()['server'].":".GetGlobalConnectionOptions()['port']."/".GetGlobalConnectionOptions()['database']."\" ";
	$str = $str."-username=\"".GetGlobalConnectionOptions()['username']."\" ";
	$str = $str."-passwd=\"".GetGlobalConnectionOptions()['password']."\" ";
	$str = $str."-loadfromdb=\"".$repname."\" ";
	$str = $str."-pdf ";
	$str = $str."-outpdf=\"".$_SERVER['DOCUMENT_ROOT']."/tmp/".$tstamp.$repname.".pdf"."\" ";
	$str = $str."-close";
	$str = $str.' -param="prmYear='.$row['year'].'" -param="prmNr='.$row['nr'].'"';

	$fnam = $rep['report_fname'] . '_' . $row['year'] . '_' . $row['nr'];
	$dir = $row['year'];

	if ($rep['report_archive'] !== '')
	{
		if ($dir !== '')
		{
			if (!file_exists($rep['report_archive'] . '/' . $dir))
			{
				mkdir($rep['report_archive'] . '/' . $dir);
			}
			$dir = $dir . '/';
		}
		$a_path = $rep['report_archive'] . '/' . $dir . $fnam . '.pdf';
		if (!file_exists($a_path))
		{
			$i++;
			$exec = exec($str);
			copy($_SERVER['DOCUMENT_ROOT'].'/tmp/'.$tstamp.$rep['report_name'].'.pdf', $a_path);
			echo 'PDF für Rechnung '.$row['year'].'/'.$row['nr'].' wurde erstellt ...<br>';
		}
	}

}

echo 'PDF Erstellung beendet!<br>';

if ($i == $max_docs)
{
	echo 'Mehr als ' . $max_docs . ' Datensätze behandelt. PDF Erstellung muss eventuell erneut gestartet werden!<br>';
}

$mask = $_SERVER['DOCUMENT_ROOT']."/tmp/mcapdf_*.pdf";
array_map( "unlink", glob( $mask ) );

$sql = 'select field from preset where section = \'database\' and param = \'content\'';
$qry = pg_query($sql);
$ret = pg_fetch_array($qry);
$content = $ret['field'];
if ($content === '')
{
	$content = 'content';
}

$path = "/" . $content . "/BMD/";
$datestamp = date('YmdHis');
$err = 0;

echo '<br>Starte BMD Export ...<br>';

/////////////////////
// DEBITOR EXPORT
/////////////////////

echo 'Debitoren werden exportiert ...<br>';

$query_data = "SET CLIENT_ENCODING TO Latin1;";
$result_data = pg_query($query_data);

$fnam = $path.$datestamp.'_debitor.csv';

$query_data = 	"
					copy (		
						SELECT     
								debitor_id AS KontoNr, 
								name1 AS Nachname, 
								name2 AS Vorname,
								street AS Strasse,
								zip AS PLZ, 
								city AS Ort,
								country as Land, 
								uid AS \"UID-Nummer\", 
						        null as IBAN,
						        null as SWIFT 
						FROM         
								contact
						WHERE     
								(not exported or exported is null) and debitor_id is not null 
						ORDER BY 
								debitor_id
						)
					to
					'".$fnam."'
					DELIMITER ';' CSV ENCODING 'Latin1'	HEADER 	
				";

$result_data = pg_query($query_data);

if (!$result_data)
{
	echo pg_last_error().'<br>';
	$err = 1;
}


/////////////////////
// BUCHUNGEN EXPORT
/////////////////////

echo 'Buchungen werden exportiert ...<br>';

$query_data = "SET CLIENT_ENCODING TO UTF8;";
$result_data = pg_query($query_data);

$sql = "
    SELECT     
            i.year,
            i.nr,
            '0' AS Satzart, 
            coalesce(case when p.debitor = '-' then null else p.debitor end, c.debitor_id) as Konto, 
            ii.financial_account AS gKonto,
            concat(to_char(i.year,'FM9999'),to_char(i.nr, 'FM000000')) as BelegNr,
            to_char(i.datestamp, 'dd.mm.yyyy') as Belegdatum,
            'AR' as Buchsymbol,
            '1' as Buchcode,
            to_char(ii.vat_percent, 'FM99') as Prozent,
            f.vat_code as Steuercode,
            to_char(ii.gross_amount, '9999990D9999') as Betrag,
            to_char(ii.vat_amount * (-1), '9999990D9999') as Steuer,
            ii.itemtext as Text,
            t.costcenter as Kost,
            t.costdivision as koschluessel,
            concat('AR_', i.year, '_', i.nr,  '.pdf') as Dokument 
    FROM         
            invoice i left outer join
            invoice_item ii on ii.year = i.year and ii.nr = i.nr left outer join
            paymenttype p on p.id = i.paymenttype left outer join
            contact c on c.id = i.contact left outer join 
            finance f on f.id = ii.financial_account left outer join
            tariff t on t.id = ii.tariff
    WHERE     
            not i.exported and i.printed 
    ORDER BY 
            i.year, i.nr, ii.item
";

echo 'Übertrage PDF Dokumente und prüfe Kontendaten ...<br>';

$sql_rep = "select field from preset where section = 'report' and param = 'print_invoice_batch_report'";
$res_rep = pg_query($sql_rep);
$row_rep = pg_fetch_assoc($res_rep);
$repname = $row_rep["field"];

$sql_rep = 'select * from report where report_name=\''.$repname.'\'';
$res_rep = pg_query($sql_rep);
$rep = pg_fetch_array($res_rep);

$result_data = pg_query($sql);
if (!$result_data)
{
	echo pg_last_error().'<br>';
	$err = 1;
}

if ($err == 0)
{
    while ($row = pg_fetch_assoc($result_data) and $err == 0)
    {
        echo 'Bearbeite Rechnung ' . $row['year'] . '/' . $row['nr'] . '<br>';

        $fnam = '_' . $row['year'] . '_' . $row['nr'];
        $dir = $row['year'];

        $a_path = $rep['report_archive'] . '/' . $dir . '/' . $rep['report_fname'] . $fnam . '.pdf';

        if (!file_exists($a_path))
        {
            $err = 1;
            echo '<b>PDF Dokument für Rechnung ' . $row['year'] . '/' . $row['nr'] . ' fehlt!</b><br>';
            echo '<b>Export wird abgebrochen. Bereits übertragene PDF Dokumente bitte manuell im Datenraum BMD löschen</b><br>';
        }
        else
        {
            if ($row['Konto'] !== '' and $row['gKonto'] !== '')
            {
                echo 'PDF Dokument ' . $rep['report_archive'] . '/' . $dir . '/' . $row['dokument'] . ' wird hochgeladen<br>';
                if (!bmd_sftp_upload($row['dokument'], $rep['report_archive'] . '/' . $dir))
                {
                    echo '<b>PDF Dokument für Rechnung ' . $row['year'] . '/' . $row['nr'] . ' konnte nicht übertragen werden!</b><br>';
                    echo '<b>Export wird abgebrochen. Bereits übertragene PDF Dokumente bitte manuell im Datenraum BMD löschen</b><br>';
                    $err = 1;
                }
            }
            else
            {
                echo '<b>Fehlende Konten bei Rechnung ' . $row['year'] . '/' . $row['nr'] . '</b><br>';
                echo '<b>Export wird abgebrochen. Bereits übertragene PDF Dokumente bitte manuell im Datenraum BMD löschen</b><br>';
                $err = 1;
            }
        }
    }
}

if ($err == 0)
{

    $sql = "
        SELECT     
                '0' AS Satzart, 
                coalesce(case when p.debitor = '-' then null else p.debitor end, c.debitor_id) as Konto, 
                ii.financial_account AS gKonto,
                concat(to_char(i.year,'FM9999'),to_char(i.nr, 'FM000000')) as BelegNr,
                to_char(i.datestamp, 'dd.mm.yyyy') as Belegdatum,
                'AR' as Buchsymbol,
                '1' as Buchcode,
                to_char(ii.vat_percent, 'FM99') as Prozent,
                f.vat_code as Steuercode,
                to_char(ii.gross_amount, '9999990D99') as Betrag,
                to_char(ii.vat_amount * (-1), '9999990D99') as Steuer,
                ii.itemtext as Text,
                t.costcenter as Kost,
                t.costdivision as koschluessel,
                concat('AR_', i.year, '_', i.nr,  '.pdf') as Dokument 
        FROM         
                invoice i left outer join
                invoice_item ii on ii.year = i.year and ii.nr = i.nr left outer join
                paymenttype p on p.id = i.paymenttype left outer join
                contact c on c.id = i.contact left outer join 
                finance f on f.id = ii.financial_account left outer join
                tariff t on t.id = ii.tariff
        WHERE     
                not i.exported and i.printed 
        ORDER BY 
                i.year, i.nr, ii.item
    ";

    $query_data = "SET CLIENT_ENCODING TO Latin1;";
    $result_data = pg_query($query_data);

    $fnam = $path.$datestamp.'_buchungen.csv';

    $query_data = "
        copy (" .
        $sql .
        "
            )
        to
        '" . $fnam . "'
        DELIMITER ';' CSV ENCODING 'Latin1'	HEADER 	
    ";
    $result_data = pg_query($query_data);
    if (!$result_data)
    {
        echo pg_last_error().'<br>';
        $err = 1;
    }
}

if ($err == 0)
{

    // transfer files to bmd
    if (!bmd_sftp_upload ($datestamp.'_debitor.csv', '/' . $content . '/BMD/'))
    {
        echo '<b>Debitor Export konnte nicht übertragen werden</b><br>';
        echo '<b>ACHTUNG: Bitte löschen Sie die partiell übertragenen Dateien manuell im Datenraum von BMD</b><br>';
        $err = 1;
    }
    if (!bmd_sftp_upload ($datestamp.'_buchungen.csv', '/' . $content . '/BMD/'))
    {
        echo '<b>Buchungsdaten Export konnte nicht übertragen werden</b><br>';
        echo '<b>ACHTUNG: Bitte löschen Sie die partiell übertragenen Dateien manuell im Datenraum von BMD</b><br>';
        $err = 1;
    }

}

if ($err == 0)
{
    pg_query('update contact set exported = true where not exported or exported is null');
    pg_query('update invoice set exported = true where not exported and printed');
	echo '<b>Export erfolgreich abgeschlossen!</b><br>';
}
else
{
	echo 'FEHLER bei Export. Daten werden zurückgesetzt ...<br>';
	if (file_exists($path.$datestamp.'_buchungen.csv'))
	{
		unlink($path . $datestamp . '_buchungen.csv');
	}
	if (file_exists($path.$datestamp.'_debitor.csv'))
	{
		unlink($path . $datestamp . '_debitor.csv');
	}
	echo 'ACHTUNG! Keine Daten exportiert! Bitte prüfen Sie ggf. manuelle Löschungen im Datenraum von BMD!<br>';
	echo '<b>Export FEHLERHAFT abgeschlossen!</b><br>Bitte beachten Sie die Fehlermeldungen und führen Sie den Export nach Korrektur erneut durch!<br>';
}

