<?php

    require_once ('../../phpgen_settings.php');

    $glob = GetGlobalConnectionOptions();
    $db = pg_connect("host=".$glob['server'].
    " port=".$glob['port'].
    " dbname=".$glob['database'].
    " user=".$glob['username'].
    " password=".$glob['password'])
    or die('Database connection failure: ' . pg_last_error());
	
	if ($_GET['query'] == 'customer_list_wms')
	{
		
		$res = pg_query($db, "select 
				cc.id as id, 
				coalesce(cc.paymenttype, '') as pay, 
				trim(coalesce(c.name2, '')) || ' ' || trim(coalesce(c.name1, '')) as name1, 
				trim(coalesce(cc.description, '')) as name2, 
				coalesce(cc.street, coalesce(c.street, '')) as street,
				coalesce(cc.zip, coalesce(c.zip, '')) as zip, 
				coalesce(cc.city, coalesce(c.city, '')) as city,
				coalesce(c.debitor_id, '') as debitor_id,
				coalesce(cc.quantity::integer::text, '') as quantity
			from 
				contact c, 
				card cc 
			where 
				cc.contact = c.id and
				c.category <> '(deleted)' and
				cc.deliverytype = 'wms' and
				(
					upper(c.id) like upper('%" . $_GET['search'] ."%') or
					upper(cc.id) like upper('%" . $_GET['search'] ."%') or
					upper(c.name1) like upper('%" . $_GET['search'] ."%') or
					upper(c.name2) like upper('%" . $_GET['search'] ."%') or
					upper(c.street) like upper('%" . $_GET['search'] ."%') or
					upper(c.zip) like upper('%" . $_GET['search'] ."%') or
					upper(c.city) like upper('%" . $_GET['search'] ."%') or
					upper(cc.description) like upper('%" . $_GET['search'] ."%') or
					upper(cc.street) like upper('%" . $_GET['search'] ."%') or
					upper(cc.zip) like upper('%" . $_GET['search'] ."%') or
					upper(cc.city) like upper('%" . $_GET['search'] ."%')
				)
			order by name1
		");
				
		$json = array();
		
		while ($row = pg_fetch_assoc($res)) {
			$json[] = $row;		
		}
		
		header("Content-Type: application/json");
		echo $_GET['callback']."(".json_encode($json).")";
		
	}
	
	if ($_GET['query'] == 'activity_reference')
	{
	
		$res = pg_query($db, "
			select distinct 
				a.reference,
				a.card,
				cc.description,
				cc.street,
				cc.zip,
				cc.city,
				coalesce(cc.paymenttype, '') as pay,
				coalesce(c.debitor_id, '') as debitor_id,
				coalesce(cc.quantity::integer::text, '') as quantity
			from 
				activity a left outer join 
				card cc on cc.id = a.card left outer join
				contact c on c.id = cc.contact
			where
				upper(a.reference) like upper('%" . $_GET['search'] ."%') and
				(a.contact = '" . $_GET['contact'] . "' or '" . $_GET['contact'] . "' = '0') and
				c.category <> '(deleted)'
			order by reference
		");
	
		$json = array();
	
		while ($row = pg_fetch_assoc($res)) {
			$json[] = $row;
		}
	
		header("Content-Type: application/json");
		echo $_GET['callback']."(".json_encode($json).")";
	
	}	
	
	if ($_GET['query'] == 'weighing_tarif')
	{
		
		if (isset($_GET['filter']))
		{
			$filter = $_GET['filter'];
		}
		else 
		{
			$filter = 'ja';
		}
		
		$res = pg_query($db, "select tariff_filter from contact where id = '" . $_GET['contact'] . "'");
		$row = pg_fetch_assoc($res);
		$tf = $row['tariff_filter'];
		
		if (($tf == '') or ($filter == 'nein'))
		{
	
			$sql = "				
					select 
						id, 
						description || ' in ' || unit as description 
					from 
						tariff 
					where 
						(
							weighing = 1::boolean or 
							id = '0'
						) 					
					order 
						by description				
			";
			
		}
		else
		{

			$sql = "
					select
						id,
						description || ' in ' || unit as description
					from
						tariff
					where
						(
							weighing = 1::boolean or
							id = '0'
						) and (
							id in (" . $tf . ") 
						)
					order
						by description
			";				
			
		}
		
		$res = pg_query($db,$sql);
		
	
		$json = array();
	
		while ($row = pg_fetch_assoc($res)) {
			$json[] = $row;
		}
	
		header("Content-Type: application/json");
		echo $_GET['callback']."(".json_encode($json).")";
	
	}

	if ($_GET['query'] == 'piece_tarif')
	{
	
		if (isset($_GET['filter']))
		{
			$filter = $_GET['filter'];
		}
		else
		{
			$filter = 'ja';
		}
	
		$res = pg_query($db, "select tariff_filter from contact where id = '" . $_GET['contact'] . "'");
		$row = pg_fetch_assoc($res);
		$tf = $row['tariff_filter'];
	
		if (($tf == '') or ($filter == 'nein'))
		{
	
			$sql = "
					select
						id,
						description || ' in ' || unit as description
					from
						tariff
					where
						(
							(weighing <> 1::boolean or weighing is null) and 
							(frqcount = 0::boolean or frqcount is null) and 
							id <> '0'					
						)
					order
						by description
			";
				
		}
		else
		{
	
			$sql = "
					select
						id,
						description || ' in ' || unit as description
					from
						tariff
					where
						(
							(weighing <> 1::boolean or weighing is null) and 
							(frqcount = 0::boolean or frqcount is null) and 
							id <> '0'					
						) and (
							id in (" . $tf . ")
						)
					order
						by description
			";
				
		}
	
		$res = pg_query($db,$sql);
	
	
		$json = array();
	
		while ($row = pg_fetch_assoc($res)) {
			$json[] = $row;
		}
	
		header("Content-Type: application/json");
		echo $_GET['callback']."(".json_encode($json).")";
	
	}	
	
?>
