<?php
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *                                   ATTENTION!
 * If you see this message in your browser (Internet Explorer, Mozilla Firefox, Google Chrome, etc.)
 * this means that PHP is not properly installed on your web server. Please refer to the PHP manual
 * for more details: http://php.net/manual/install.php 
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

    include_once dirname(__FILE__) . '/components/startup.php';
    include_once dirname(__FILE__) . '/components/application.php';
    include_once dirname(__FILE__) . '/' . 'authorization.php';


    include_once dirname(__FILE__) . '/' . 'database_engine/pgsql_engine.php';
    include_once dirname(__FILE__) . '/' . 'components/page/page_includes.php';

    function GetConnectionOptions()
    {
        $result = GetGlobalConnectionOptions();
        $result['client_encoding'] = 'utf8';
        GetApplication()->GetUserAuthentication()->applyIdentityToConnectionOptions($result);
        return $result;
    }

    
    
    
    // OnBeforePageExecute event handler
    
    
    
    class public_qedm_resultPage extends Page
    {
        protected function DoBeforeCreate()
        {
            $this->SetTitle('');
            $this->SetMenuLabel('Logistik Meldung Detail');
            $this->SetHeader(GetPagesHeader());
            $this->SetFooter(GetPagesFooter());
    
            $this->dataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qedm_result"');
            $this->dataset->addFields(
                array(
                    new StringField('buchung', false, true),
                    new StringField('buchungsart'),
                    new StringField('gtin', false, true),
                    new StringField('sn'),
                    new StringField('sp'),
                    new StringField('g_gn'),
                    new StringField('abfallart'),
                    new StringField('kontamination'),
                    new IntegerField('masse'),
                    new StringField('periode'),
                    new StringField('herkunft', false, true),
                    new StringField('herkunft_typ'),
                    new StringField('herkunft_text'),
                    new StringField('herkunft_vtyp'),
                    new StringField('herkunft_vtext'),
                    new StringField('verbleib', false, true),
                    new StringField('verbleib_typ'),
                    new StringField('verbleib_text'),
                    new StringField('verbleib_vtyp'),
                    new StringField('verbleib_vtext'),
                    new StringField('herkunft_name'),
                    new StringField('herkunft_strasse'),
                    new StringField('herkunft_strasse_nr'),
                    new StringField('herkunft_land'),
                    new StringField('herkunft_plz'),
                    new StringField('herkunft_ort'),
                    new StringField('verbleib_name'),
                    new StringField('verbleib_strasse'),
                    new StringField('verbleib_strasse_nr'),
                    new StringField('verbleib_land'),
                    new StringField('verbleib_plz'),
                    new StringField('verbleib_ort'),
                    new StringField('report_gln')
                )
            );
            $this->dataset->AddLookupField('herkunft', 'public.contact_edm_gln', new StringField('gln'), new StringField('description', false, false, false, false, 'LA1', 'LT1'), 'LT1');
            $this->dataset->AddLookupField('verbleib', 'public.contact_edm_gln', new StringField('gln'), new StringField('description', false, false, false, false, 'LA2', 'LT2'), 'LT2');
            $this->dataset->AddLookupField('report_gln', 'public.contact_edm_gln', new StringField('gln'), new StringField('description', false, false, false, false, 'LA3', 'LT3'), 'LT3');
        }
    
        protected function DoPrepare() {
    
        }
    
        protected function CreatePageNavigator()
        {
            $result = new CompositePageNavigator($this);
            
            $partitionNavigator = new PageNavigator('pnav', $this, $this->dataset);
            $partitionNavigator->SetRowsPerPage(10);
            $result->AddPageNavigator($partitionNavigator);
            
            return $result;
        }
    
        protected function CreateRssGenerator()
        {
            return null;
        }
    
        protected function setupCharts()
        {
    
        }
    
        protected function getFiltersColumns()
        {
            return array(
                new FilterColumn($this->dataset, 'periode', 'periode', 'Periode'),
                new FilterColumn($this->dataset, 'buchungsart', 'buchungsart', 'Buchungsart'),
                new FilterColumn($this->dataset, 'sn', 'sn', 'Sn'),
                new FilterColumn($this->dataset, 'sp', 'sp', 'Sp'),
                new FilterColumn($this->dataset, 'abfallart', 'abfallart', 'Abfallart'),
                new FilterColumn($this->dataset, 'masse', 'masse', 'Masse'),
                new FilterColumn($this->dataset, 'herkunft', 'LA1', 'Herkunft'),
                new FilterColumn($this->dataset, 'herkunft_typ', 'herkunft_typ', 'Herkunft Typ'),
                new FilterColumn($this->dataset, 'herkunft_text', 'herkunft_text', 'Herkunft Text'),
                new FilterColumn($this->dataset, 'verbleib', 'LA2', 'Verbleib'),
                new FilterColumn($this->dataset, 'verbleib_typ', 'verbleib_typ', 'Verbleib Typ'),
                new FilterColumn($this->dataset, 'verbleib_text', 'verbleib_text', 'Verbleib Text'),
                new FilterColumn($this->dataset, 'herkunft_name', 'herkunft_name', 'Herkunft Name'),
                new FilterColumn($this->dataset, 'verbleib_name', 'verbleib_name', 'Verbleib Name'),
                new FilterColumn($this->dataset, 'buchung', 'buchung', 'Buchung'),
                new FilterColumn($this->dataset, 'gtin', 'gtin', 'Gtin'),
                new FilterColumn($this->dataset, 'g_gn', 'g_gn', 'G Gn'),
                new FilterColumn($this->dataset, 'kontamination', 'kontamination', 'Kontamination'),
                new FilterColumn($this->dataset, 'herkunft_vtyp', 'herkunft_vtyp', 'Herk. Verf. GLN'),
                new FilterColumn($this->dataset, 'herkunft_vtext', 'herkunft_vtext', 'Herk. Verf.'),
                new FilterColumn($this->dataset, 'verbleib_vtyp', 'verbleib_vtyp', 'Verbl. Verf. GLN'),
                new FilterColumn($this->dataset, 'verbleib_vtext', 'verbleib_vtext', 'Verbl. Verf. '),
                new FilterColumn($this->dataset, 'herkunft_strasse', 'herkunft_strasse', 'Herkunft Strasse'),
                new FilterColumn($this->dataset, 'herkunft_strasse_nr', 'herkunft_strasse_nr', 'Herkunft Strasse Nr'),
                new FilterColumn($this->dataset, 'herkunft_land', 'herkunft_land', 'Herkunft Land'),
                new FilterColumn($this->dataset, 'herkunft_plz', 'herkunft_plz', 'Herkunft Plz'),
                new FilterColumn($this->dataset, 'herkunft_ort', 'herkunft_ort', 'Herkunft Ort'),
                new FilterColumn($this->dataset, 'verbleib_strasse', 'verbleib_strasse', 'Verbleib Strasse'),
                new FilterColumn($this->dataset, 'verbleib_strasse_nr', 'verbleib_strasse_nr', 'Verbleib Strasse Nr'),
                new FilterColumn($this->dataset, 'verbleib_land', 'verbleib_land', 'Verbleib Land'),
                new FilterColumn($this->dataset, 'verbleib_plz', 'verbleib_plz', 'Verbleib Plz'),
                new FilterColumn($this->dataset, 'verbleib_ort', 'verbleib_ort', 'Verbleib Ort'),
                new FilterColumn($this->dataset, 'report_gln', 'LA3', 'Report Gln')
            );
        }
    
        protected function setupQuickFilter(QuickFilter $quickFilter, FixedKeysArray $columns)
        {
            $quickFilter
                ->addColumn($columns['periode'])
                ->addColumn($columns['buchungsart'])
                ->addColumn($columns['sn'])
                ->addColumn($columns['abfallart'])
                ->addColumn($columns['masse'])
                ->addColumn($columns['herkunft'])
                ->addColumn($columns['herkunft_typ'])
                ->addColumn($columns['verbleib'])
                ->addColumn($columns['verbleib_typ'])
                ->addColumn($columns['buchung'])
                ->addColumn($columns['gtin'])
                ->addColumn($columns['sp'])
                ->addColumn($columns['g_gn'])
                ->addColumn($columns['kontamination'])
                ->addColumn($columns['herkunft_text'])
                ->addColumn($columns['herkunft_vtyp'])
                ->addColumn($columns['herkunft_vtext'])
                ->addColumn($columns['verbleib_text'])
                ->addColumn($columns['verbleib_vtyp'])
                ->addColumn($columns['verbleib_vtext'])
                ->addColumn($columns['herkunft_name'])
                ->addColumn($columns['herkunft_strasse'])
                ->addColumn($columns['herkunft_strasse_nr'])
                ->addColumn($columns['herkunft_land'])
                ->addColumn($columns['herkunft_plz'])
                ->addColumn($columns['herkunft_ort'])
                ->addColumn($columns['verbleib_name'])
                ->addColumn($columns['verbleib_strasse'])
                ->addColumn($columns['verbleib_strasse_nr'])
                ->addColumn($columns['verbleib_land'])
                ->addColumn($columns['verbleib_plz'])
                ->addColumn($columns['verbleib_ort'])
                ->addColumn($columns['report_gln']);
        }
    
        protected function setupColumnFilter(ColumnFilter $columnFilter)
        {
            $columnFilter
                ->setOptionsFor('periode')
                ->setOptionsFor('buchungsart')
                ->setOptionsFor('sn')
                ->setOptionsFor('abfallart')
                ->setOptionsFor('herkunft')
                ->setOptionsFor('herkunft_typ')
                ->setOptionsFor('verbleib')
                ->setOptionsFor('verbleib_typ')
                ->setOptionsFor('report_gln');
        }
    
        protected function setupFilterBuilder(FilterBuilder $filterBuilder, FixedKeysArray $columns)
        {
            $main_editor = new TextEdit('periode_edit');
            
            $filterBuilder->addColumn(
                $columns['periode'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('buchungsart_edit');
            
            $filterBuilder->addColumn(
                $columns['buchungsart'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('sn_edit');
            
            $filterBuilder->addColumn(
                $columns['sn'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('sp_edit');
            
            $filterBuilder->addColumn(
                $columns['sp'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('abfallart_edit');
            
            $filterBuilder->addColumn(
                $columns['abfallart'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('masse_edit');
            
            $filterBuilder->addColumn(
                $columns['masse'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('herkunft_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_qedm_result_herkunft_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('herkunft', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_qedm_result_herkunft_search');
            
            $text_editor = new TextEdit('herkunft');
            
            $filterBuilder->addColumn(
                $columns['herkunft'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('herkunft_typ_edit');
            
            $filterBuilder->addColumn(
                $columns['herkunft_typ'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('herkunft_text_edit');
            
            $filterBuilder->addColumn(
                $columns['herkunft_text'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('verbleib_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_qedm_result_verbleib_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('verbleib', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_qedm_result_verbleib_search');
            
            $text_editor = new TextEdit('verbleib');
            
            $filterBuilder->addColumn(
                $columns['verbleib'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('verbleib_typ_edit');
            
            $filterBuilder->addColumn(
                $columns['verbleib_typ'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('verbleib_text_edit');
            
            $filterBuilder->addColumn(
                $columns['verbleib_text'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('herkunft_name_edit');
            
            $filterBuilder->addColumn(
                $columns['herkunft_name'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('verbleib_name_edit');
            
            $filterBuilder->addColumn(
                $columns['verbleib_name'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('buchung_edit');
            
            $filterBuilder->addColumn(
                $columns['buchung'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('gtin_edit');
            
            $filterBuilder->addColumn(
                $columns['gtin'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('g_gn_edit');
            
            $filterBuilder->addColumn(
                $columns['g_gn'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('kontamination_edit');
            
            $filterBuilder->addColumn(
                $columns['kontamination'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('herkunft_vtyp_edit');
            
            $filterBuilder->addColumn(
                $columns['herkunft_vtyp'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('herkunft_vtext_edit');
            
            $filterBuilder->addColumn(
                $columns['herkunft_vtext'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('verbleib_vtyp_edit');
            
            $filterBuilder->addColumn(
                $columns['verbleib_vtyp'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('verbleib_vtext_edit');
            
            $filterBuilder->addColumn(
                $columns['verbleib_vtext'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('herkunft_strasse_edit');
            
            $filterBuilder->addColumn(
                $columns['herkunft_strasse'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('herkunft_strasse_nr_edit');
            
            $filterBuilder->addColumn(
                $columns['herkunft_strasse_nr'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('herkunft_land_edit');
            
            $filterBuilder->addColumn(
                $columns['herkunft_land'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('herkunft_plz_edit');
            
            $filterBuilder->addColumn(
                $columns['herkunft_plz'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('herkunft_ort_edit');
            
            $filterBuilder->addColumn(
                $columns['herkunft_ort'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('verbleib_strasse_edit');
            
            $filterBuilder->addColumn(
                $columns['verbleib_strasse'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('verbleib_strasse_nr_edit');
            
            $filterBuilder->addColumn(
                $columns['verbleib_strasse_nr'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('verbleib_land_edit');
            
            $filterBuilder->addColumn(
                $columns['verbleib_land'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('verbleib_plz_edit');
            
            $filterBuilder->addColumn(
                $columns['verbleib_plz'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('verbleib_ort_edit');
            
            $filterBuilder->addColumn(
                $columns['verbleib_ort'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('report_gln_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_qedm_result_report_gln_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('report_gln', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_qedm_result_report_gln_search');
            
            $text_editor = new TextEdit('report_gln');
            
            $filterBuilder->addColumn(
                $columns['report_gln'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
        }
    
        protected function AddOperationsColumns(Grid $grid)
        {
            $actions = $grid->getActions();
            $actions->setCaption($this->GetLocalizerCaptions()->GetMessageString('Actions'));
            $actions->setPosition(ActionList::POSITION_LEFT);
            
            if ($this->GetSecurityInfo()->HasViewGrant())
            {
                $operation = new LinkOperation($this->GetLocalizerCaptions()->GetMessageString('View'), OPERATION_VIEW, $this->dataset, $grid);
                $operation->setUseImage(true);
                $actions->addOperation($operation);
            }
        }
    
        protected function AddFieldColumns(Grid $grid, $withDetails = true)
        {
            //
            // View column for periode field
            //
            $column = new TextViewColumn('periode', 'periode', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_periode_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for buchungsart field
            //
            $column = new TextViewColumn('buchungsart', 'buchungsart', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_buchungsart_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for sn field
            //
            $column = new TextViewColumn('sn', 'sn', 'Sn', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_sn_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for abfallart field
            //
            $column = new TextViewColumn('abfallart', 'abfallart', 'Abfallart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_abfallart_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for masse field
            //
            $column = new NumberViewColumn('masse', 'masse', 'Masse', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(0);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('herkunft', 'LA1', 'Herkunft', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_LA1_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for herkunft_typ field
            //
            $column = new TextViewColumn('herkunft_typ', 'herkunft_typ', 'Herkunft Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_typ_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('verbleib', 'LA2', 'Verbleib', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_LA2_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for verbleib_typ field
            //
            $column = new TextViewColumn('verbleib_typ', 'verbleib_typ', 'Verbleib Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_typ_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA3', 'Report Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_LA3_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
        }
    
        protected function AddSingleRecordViewColumns(Grid $grid)
        {
            //
            // View column for periode field
            //
            $column = new TextViewColumn('periode', 'periode', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_periode_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for buchungsart field
            //
            $column = new TextViewColumn('buchungsart', 'buchungsart', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_buchungsart_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for sn field
            //
            $column = new TextViewColumn('sn', 'sn', 'Sn', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_sn_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for sp field
            //
            $column = new TextViewColumn('sp', 'sp', 'Sp', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_sp_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for abfallart field
            //
            $column = new TextViewColumn('abfallart', 'abfallart', 'Abfallart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_abfallart_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for masse field
            //
            $column = new NumberViewColumn('masse', 'masse', 'Masse', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(0);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('herkunft', 'LA1', 'Herkunft', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_LA1_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for herkunft_typ field
            //
            $column = new TextViewColumn('herkunft_typ', 'herkunft_typ', 'Herkunft Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_typ_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for herkunft_text field
            //
            $column = new TextViewColumn('herkunft_text', 'herkunft_text', 'Herkunft Text', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_text_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('verbleib', 'LA2', 'Verbleib', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_LA2_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for verbleib_typ field
            //
            $column = new TextViewColumn('verbleib_typ', 'verbleib_typ', 'Verbleib Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_typ_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for verbleib_text field
            //
            $column = new TextViewColumn('verbleib_text', 'verbleib_text', 'Verbleib Text', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_text_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for herkunft_name field
            //
            $column = new TextViewColumn('herkunft_name', 'herkunft_name', 'Herkunft Name', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_name_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for verbleib_name field
            //
            $column = new TextViewColumn('verbleib_name', 'verbleib_name', 'Verbleib Name', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_name_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for buchung field
            //
            $column = new TextViewColumn('buchung', 'buchung', 'Buchung', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_buchung_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for gtin field
            //
            $column = new TextViewColumn('gtin', 'gtin', 'Gtin', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_gtin_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for g_gn field
            //
            $column = new TextViewColumn('g_gn', 'g_gn', 'G Gn', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_g_gn_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for kontamination field
            //
            $column = new TextViewColumn('kontamination', 'kontamination', 'Kontamination', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_kontamination_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for herkunft_vtyp field
            //
            $column = new TextViewColumn('herkunft_vtyp', 'herkunft_vtyp', 'Herk. Verf. GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_vtyp_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for herkunft_vtext field
            //
            $column = new TextViewColumn('herkunft_vtext', 'herkunft_vtext', 'Herk. Verf.', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_vtext_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for verbleib_vtyp field
            //
            $column = new TextViewColumn('verbleib_vtyp', 'verbleib_vtyp', 'Verbl. Verf. GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_vtyp_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for verbleib_vtext field
            //
            $column = new TextViewColumn('verbleib_vtext', 'verbleib_vtext', 'Verbl. Verf. ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_vtext_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for herkunft_strasse field
            //
            $column = new TextViewColumn('herkunft_strasse', 'herkunft_strasse', 'Herkunft Strasse', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_strasse_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for herkunft_strasse_nr field
            //
            $column = new TextViewColumn('herkunft_strasse_nr', 'herkunft_strasse_nr', 'Herkunft Strasse Nr', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_strasse_nr_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for herkunft_land field
            //
            $column = new TextViewColumn('herkunft_land', 'herkunft_land', 'Herkunft Land', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_land_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for herkunft_plz field
            //
            $column = new TextViewColumn('herkunft_plz', 'herkunft_plz', 'Herkunft Plz', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_plz_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for herkunft_ort field
            //
            $column = new TextViewColumn('herkunft_ort', 'herkunft_ort', 'Herkunft Ort', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_ort_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for verbleib_strasse field
            //
            $column = new TextViewColumn('verbleib_strasse', 'verbleib_strasse', 'Verbleib Strasse', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_strasse_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for verbleib_strasse_nr field
            //
            $column = new TextViewColumn('verbleib_strasse_nr', 'verbleib_strasse_nr', 'Verbleib Strasse Nr', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_strasse_nr_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for verbleib_land field
            //
            $column = new TextViewColumn('verbleib_land', 'verbleib_land', 'Verbleib Land', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_land_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for verbleib_plz field
            //
            $column = new TextViewColumn('verbleib_plz', 'verbleib_plz', 'Verbleib Plz', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_plz_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for verbleib_ort field
            //
            $column = new TextViewColumn('verbleib_ort', 'verbleib_ort', 'Verbleib Ort', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_ort_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA3', 'Report Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_LA3_handler_view');
            $grid->AddSingleRecordViewColumn($column);
        }
    
        protected function AddEditColumns(Grid $grid)
        {
            //
            // Edit column for periode field
            //
            $editor = new TextEdit('periode_edit');
            $editColumn = new CustomEditColumn('Periode', 'periode', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for buchungsart field
            //
            $editor = new TextEdit('buchungsart_edit');
            $editColumn = new CustomEditColumn('Buchungsart', 'buchungsart', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for sn field
            //
            $editor = new TextEdit('sn_edit');
            $editColumn = new CustomEditColumn('Sn', 'sn', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for sp field
            //
            $editor = new TextEdit('sp_edit');
            $editColumn = new CustomEditColumn('Sp', 'sp', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for abfallart field
            //
            $editor = new TextEdit('abfallart_edit');
            $editColumn = new CustomEditColumn('Abfallart', 'abfallart', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for masse field
            //
            $editor = new TextEdit('masse_edit');
            $editColumn = new CustomEditColumn('Masse', 'masse', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for herkunft field
            //
            $editor = new DynamicCombobox('herkunft_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Herkunft', 'herkunft', 'LA1', 'edit_public_qedm_result_herkunft_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for herkunft_typ field
            //
            $editor = new TextEdit('herkunft_typ_edit');
            $editColumn = new CustomEditColumn('Herkunft Typ', 'herkunft_typ', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for herkunft_text field
            //
            $editor = new TextEdit('herkunft_text_edit');
            $editColumn = new CustomEditColumn('Herkunft Text', 'herkunft_text', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for verbleib field
            //
            $editor = new DynamicCombobox('verbleib_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Verbleib', 'verbleib', 'LA2', 'edit_public_qedm_result_verbleib_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for verbleib_typ field
            //
            $editor = new TextEdit('verbleib_typ_edit');
            $editColumn = new CustomEditColumn('Verbleib Typ', 'verbleib_typ', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for verbleib_text field
            //
            $editor = new TextEdit('verbleib_text_edit');
            $editColumn = new CustomEditColumn('Verbleib Text', 'verbleib_text', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for herkunft_name field
            //
            $editor = new TextEdit('herkunft_name_edit');
            $editColumn = new CustomEditColumn('Herkunft Name', 'herkunft_name', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for verbleib_name field
            //
            $editor = new TextEdit('verbleib_name_edit');
            $editColumn = new CustomEditColumn('Verbleib Name', 'verbleib_name', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for buchung field
            //
            $editor = new TextEdit('buchung_edit');
            $editColumn = new CustomEditColumn('Buchung', 'buchung', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for gtin field
            //
            $editor = new TextEdit('gtin_edit');
            $editColumn = new CustomEditColumn('Gtin', 'gtin', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for g_gn field
            //
            $editor = new TextEdit('g_gn_edit');
            $editColumn = new CustomEditColumn('G Gn', 'g_gn', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for kontamination field
            //
            $editor = new TextEdit('kontamination_edit');
            $editColumn = new CustomEditColumn('Kontamination', 'kontamination', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for herkunft_vtyp field
            //
            $editor = new TextEdit('herkunft_vtyp_edit');
            $editColumn = new CustomEditColumn('Herk. Verf. GLN', 'herkunft_vtyp', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for herkunft_vtext field
            //
            $editor = new TextEdit('herkunft_vtext_edit');
            $editColumn = new CustomEditColumn('Herk. Verf.', 'herkunft_vtext', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for verbleib_vtyp field
            //
            $editor = new TextEdit('verbleib_vtyp_edit');
            $editColumn = new CustomEditColumn('Verbl. Verf. GLN', 'verbleib_vtyp', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for verbleib_vtext field
            //
            $editor = new TextEdit('verbleib_vtext_edit');
            $editColumn = new CustomEditColumn('Verbl. Verf. ', 'verbleib_vtext', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for herkunft_strasse field
            //
            $editor = new TextEdit('herkunft_strasse_edit');
            $editColumn = new CustomEditColumn('Herkunft Strasse', 'herkunft_strasse', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for herkunft_strasse_nr field
            //
            $editor = new TextEdit('herkunft_strasse_nr_edit');
            $editColumn = new CustomEditColumn('Herkunft Strasse Nr', 'herkunft_strasse_nr', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for herkunft_land field
            //
            $editor = new TextEdit('herkunft_land_edit');
            $editColumn = new CustomEditColumn('Herkunft Land', 'herkunft_land', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for herkunft_plz field
            //
            $editor = new TextEdit('herkunft_plz_edit');
            $editColumn = new CustomEditColumn('Herkunft Plz', 'herkunft_plz', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for herkunft_ort field
            //
            $editor = new TextEdit('herkunft_ort_edit');
            $editColumn = new CustomEditColumn('Herkunft Ort', 'herkunft_ort', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for verbleib_strasse field
            //
            $editor = new TextEdit('verbleib_strasse_edit');
            $editColumn = new CustomEditColumn('Verbleib Strasse', 'verbleib_strasse', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for verbleib_strasse_nr field
            //
            $editor = new TextEdit('verbleib_strasse_nr_edit');
            $editColumn = new CustomEditColumn('Verbleib Strasse Nr', 'verbleib_strasse_nr', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for verbleib_land field
            //
            $editor = new TextEdit('verbleib_land_edit');
            $editColumn = new CustomEditColumn('Verbleib Land', 'verbleib_land', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for verbleib_plz field
            //
            $editor = new TextEdit('verbleib_plz_edit');
            $editColumn = new CustomEditColumn('Verbleib Plz', 'verbleib_plz', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for verbleib_ort field
            //
            $editor = new TextEdit('verbleib_ort_edit');
            $editColumn = new CustomEditColumn('Verbleib Ort', 'verbleib_ort', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for report_gln field
            //
            $editor = new DynamicCombobox('report_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Report Gln', 'report_gln', 'LA3', 'edit_public_qedm_result_report_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
        }
    
        protected function AddMultiEditColumns(Grid $grid)
        {
            //
            // Edit column for periode field
            //
            $editor = new TextEdit('periode_edit');
            $editColumn = new CustomEditColumn('Periode', 'periode', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for buchungsart field
            //
            $editor = new TextEdit('buchungsart_edit');
            $editColumn = new CustomEditColumn('Buchungsart', 'buchungsart', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for sn field
            //
            $editor = new TextEdit('sn_edit');
            $editColumn = new CustomEditColumn('Sn', 'sn', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for abfallart field
            //
            $editor = new TextEdit('abfallart_edit');
            $editColumn = new CustomEditColumn('Abfallart', 'abfallart', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for masse field
            //
            $editor = new TextEdit('masse_edit');
            $editColumn = new CustomEditColumn('Masse', 'masse', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for herkunft field
            //
            $editor = new DynamicCombobox('herkunft_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Herkunft', 'herkunft', 'LA1', 'multi_edit_public_qedm_result_herkunft_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for herkunft_typ field
            //
            $editor = new TextEdit('herkunft_typ_edit');
            $editColumn = new CustomEditColumn('Herkunft Typ', 'herkunft_typ', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for verbleib field
            //
            $editor = new DynamicCombobox('verbleib_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Verbleib', 'verbleib', 'LA2', 'multi_edit_public_qedm_result_verbleib_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for verbleib_typ field
            //
            $editor = new TextEdit('verbleib_typ_edit');
            $editColumn = new CustomEditColumn('Verbleib Typ', 'verbleib_typ', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for buchung field
            //
            $editor = new TextEdit('buchung_edit');
            $editColumn = new CustomEditColumn('Buchung', 'buchung', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for gtin field
            //
            $editor = new TextEdit('gtin_edit');
            $editColumn = new CustomEditColumn('Gtin', 'gtin', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for sp field
            //
            $editor = new TextEdit('sp_edit');
            $editColumn = new CustomEditColumn('Sp', 'sp', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for g_gn field
            //
            $editor = new TextEdit('g_gn_edit');
            $editColumn = new CustomEditColumn('G Gn', 'g_gn', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for kontamination field
            //
            $editor = new TextEdit('kontamination_edit');
            $editColumn = new CustomEditColumn('Kontamination', 'kontamination', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for herkunft_text field
            //
            $editor = new TextEdit('herkunft_text_edit');
            $editColumn = new CustomEditColumn('Herkunft Text', 'herkunft_text', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for herkunft_vtyp field
            //
            $editor = new TextEdit('herkunft_vtyp_edit');
            $editColumn = new CustomEditColumn('Herkunft Vtyp', 'herkunft_vtyp', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for herkunft_vtext field
            //
            $editor = new TextEdit('herkunft_vtext_edit');
            $editColumn = new CustomEditColumn('Herkunft Vtext', 'herkunft_vtext', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for verbleib_text field
            //
            $editor = new TextEdit('verbleib_text_edit');
            $editColumn = new CustomEditColumn('Verbleib Text', 'verbleib_text', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for verbleib_vtyp field
            //
            $editor = new TextEdit('verbleib_vtyp_edit');
            $editColumn = new CustomEditColumn('Verbleib Vtyp', 'verbleib_vtyp', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for verbleib_vtext field
            //
            $editor = new TextEdit('verbleib_vtext_edit');
            $editColumn = new CustomEditColumn('Verbleib Vtext', 'verbleib_vtext', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for herkunft_name field
            //
            $editor = new TextEdit('herkunft_name_edit');
            $editColumn = new CustomEditColumn('Herkunft Name', 'herkunft_name', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for herkunft_strasse field
            //
            $editor = new TextEdit('herkunft_strasse_edit');
            $editColumn = new CustomEditColumn('Herkunft Strasse', 'herkunft_strasse', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for herkunft_strasse_nr field
            //
            $editor = new TextEdit('herkunft_strasse_nr_edit');
            $editColumn = new CustomEditColumn('Herkunft Strasse Nr', 'herkunft_strasse_nr', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for herkunft_land field
            //
            $editor = new TextEdit('herkunft_land_edit');
            $editColumn = new CustomEditColumn('Herkunft Land', 'herkunft_land', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for herkunft_plz field
            //
            $editor = new TextEdit('herkunft_plz_edit');
            $editColumn = new CustomEditColumn('Herkunft Plz', 'herkunft_plz', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for herkunft_ort field
            //
            $editor = new TextEdit('herkunft_ort_edit');
            $editColumn = new CustomEditColumn('Herkunft Ort', 'herkunft_ort', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for verbleib_name field
            //
            $editor = new TextEdit('verbleib_name_edit');
            $editColumn = new CustomEditColumn('Verbleib Name', 'verbleib_name', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for verbleib_strasse field
            //
            $editor = new TextEdit('verbleib_strasse_edit');
            $editColumn = new CustomEditColumn('Verbleib Strasse', 'verbleib_strasse', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for verbleib_strasse_nr field
            //
            $editor = new TextEdit('verbleib_strasse_nr_edit');
            $editColumn = new CustomEditColumn('Verbleib Strasse Nr', 'verbleib_strasse_nr', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for verbleib_land field
            //
            $editor = new TextEdit('verbleib_land_edit');
            $editColumn = new CustomEditColumn('Verbleib Land', 'verbleib_land', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for verbleib_plz field
            //
            $editor = new TextEdit('verbleib_plz_edit');
            $editColumn = new CustomEditColumn('Verbleib Plz', 'verbleib_plz', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for verbleib_ort field
            //
            $editor = new TextEdit('verbleib_ort_edit');
            $editColumn = new CustomEditColumn('Verbleib Ort', 'verbleib_ort', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for report_gln field
            //
            $editor = new DynamicCombobox('report_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Report Gln', 'report_gln', 'LA3', 'multi_edit_public_qedm_result_report_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
        }
    
        protected function AddInsertColumns(Grid $grid)
        {
            //
            // Edit column for periode field
            //
            $editor = new TextEdit('periode_edit');
            $editColumn = new CustomEditColumn('Periode', 'periode', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for buchungsart field
            //
            $editor = new TextEdit('buchungsart_edit');
            $editColumn = new CustomEditColumn('Buchungsart', 'buchungsart', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for sn field
            //
            $editor = new TextEdit('sn_edit');
            $editColumn = new CustomEditColumn('Sn', 'sn', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for sp field
            //
            $editor = new TextEdit('sp_edit');
            $editColumn = new CustomEditColumn('Sp', 'sp', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for abfallart field
            //
            $editor = new TextEdit('abfallart_edit');
            $editColumn = new CustomEditColumn('Abfallart', 'abfallart', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for masse field
            //
            $editor = new TextEdit('masse_edit');
            $editColumn = new CustomEditColumn('Masse', 'masse', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for herkunft field
            //
            $editor = new DynamicCombobox('herkunft_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Herkunft', 'herkunft', 'LA1', 'insert_public_qedm_result_herkunft_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for herkunft_typ field
            //
            $editor = new TextEdit('herkunft_typ_edit');
            $editColumn = new CustomEditColumn('Herkunft Typ', 'herkunft_typ', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for herkunft_text field
            //
            $editor = new TextEdit('herkunft_text_edit');
            $editColumn = new CustomEditColumn('Herkunft Text', 'herkunft_text', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for verbleib field
            //
            $editor = new DynamicCombobox('verbleib_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Verbleib', 'verbleib', 'LA2', 'insert_public_qedm_result_verbleib_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for verbleib_typ field
            //
            $editor = new TextEdit('verbleib_typ_edit');
            $editColumn = new CustomEditColumn('Verbleib Typ', 'verbleib_typ', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for verbleib_text field
            //
            $editor = new TextEdit('verbleib_text_edit');
            $editColumn = new CustomEditColumn('Verbleib Text', 'verbleib_text', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for herkunft_name field
            //
            $editor = new TextEdit('herkunft_name_edit');
            $editColumn = new CustomEditColumn('Herkunft Name', 'herkunft_name', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for verbleib_name field
            //
            $editor = new TextEdit('verbleib_name_edit');
            $editColumn = new CustomEditColumn('Verbleib Name', 'verbleib_name', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for buchung field
            //
            $editor = new TextEdit('buchung_edit');
            $editColumn = new CustomEditColumn('Buchung', 'buchung', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for gtin field
            //
            $editor = new TextEdit('gtin_edit');
            $editColumn = new CustomEditColumn('Gtin', 'gtin', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for g_gn field
            //
            $editor = new TextEdit('g_gn_edit');
            $editColumn = new CustomEditColumn('G Gn', 'g_gn', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for kontamination field
            //
            $editor = new TextEdit('kontamination_edit');
            $editColumn = new CustomEditColumn('Kontamination', 'kontamination', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for herkunft_vtyp field
            //
            $editor = new TextEdit('herkunft_vtyp_edit');
            $editColumn = new CustomEditColumn('Herk. Verf. GLN', 'herkunft_vtyp', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for herkunft_vtext field
            //
            $editor = new TextEdit('herkunft_vtext_edit');
            $editColumn = new CustomEditColumn('Herk. Verf.', 'herkunft_vtext', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for verbleib_vtyp field
            //
            $editor = new TextEdit('verbleib_vtyp_edit');
            $editColumn = new CustomEditColumn('Verbl. Verf. GLN', 'verbleib_vtyp', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for verbleib_vtext field
            //
            $editor = new TextEdit('verbleib_vtext_edit');
            $editColumn = new CustomEditColumn('Verbl. Verf. ', 'verbleib_vtext', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for herkunft_strasse field
            //
            $editor = new TextEdit('herkunft_strasse_edit');
            $editColumn = new CustomEditColumn('Herkunft Strasse', 'herkunft_strasse', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for herkunft_strasse_nr field
            //
            $editor = new TextEdit('herkunft_strasse_nr_edit');
            $editColumn = new CustomEditColumn('Herkunft Strasse Nr', 'herkunft_strasse_nr', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for herkunft_land field
            //
            $editor = new TextEdit('herkunft_land_edit');
            $editColumn = new CustomEditColumn('Herkunft Land', 'herkunft_land', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for herkunft_plz field
            //
            $editor = new TextEdit('herkunft_plz_edit');
            $editColumn = new CustomEditColumn('Herkunft Plz', 'herkunft_plz', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for herkunft_ort field
            //
            $editor = new TextEdit('herkunft_ort_edit');
            $editColumn = new CustomEditColumn('Herkunft Ort', 'herkunft_ort', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for verbleib_strasse field
            //
            $editor = new TextEdit('verbleib_strasse_edit');
            $editColumn = new CustomEditColumn('Verbleib Strasse', 'verbleib_strasse', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for verbleib_strasse_nr field
            //
            $editor = new TextEdit('verbleib_strasse_nr_edit');
            $editColumn = new CustomEditColumn('Verbleib Strasse Nr', 'verbleib_strasse_nr', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for verbleib_land field
            //
            $editor = new TextEdit('verbleib_land_edit');
            $editColumn = new CustomEditColumn('Verbleib Land', 'verbleib_land', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for verbleib_plz field
            //
            $editor = new TextEdit('verbleib_plz_edit');
            $editColumn = new CustomEditColumn('Verbleib Plz', 'verbleib_plz', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for verbleib_ort field
            //
            $editor = new TextEdit('verbleib_ort_edit');
            $editColumn = new CustomEditColumn('Verbleib Ort', 'verbleib_ort', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for report_gln field
            //
            $editor = new DynamicCombobox('report_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Report Gln', 'report_gln', 'LA3', 'insert_public_qedm_result_report_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            $grid->SetShowAddButton(false && $this->GetSecurityInfo()->HasAddGrant());
        }
    
        private function AddMultiUploadColumn(Grid $grid)
        {
    
        }
    
        protected function AddPrintColumns(Grid $grid)
        {
            //
            // View column for periode field
            //
            $column = new TextViewColumn('periode', 'periode', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_periode_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for buchungsart field
            //
            $column = new TextViewColumn('buchungsart', 'buchungsart', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_buchungsart_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for sn field
            //
            $column = new TextViewColumn('sn', 'sn', 'Sn', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_sn_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for sp field
            //
            $column = new TextViewColumn('sp', 'sp', 'Sp', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_sp_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for abfallart field
            //
            $column = new TextViewColumn('abfallart', 'abfallart', 'Abfallart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_abfallart_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for masse field
            //
            $column = new NumberViewColumn('masse', 'masse', 'Masse', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(0);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddPrintColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('herkunft', 'LA1', 'Herkunft', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_LA1_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for herkunft_typ field
            //
            $column = new TextViewColumn('herkunft_typ', 'herkunft_typ', 'Herkunft Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_typ_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for herkunft_text field
            //
            $column = new TextViewColumn('herkunft_text', 'herkunft_text', 'Herkunft Text', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_text_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('verbleib', 'LA2', 'Verbleib', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_LA2_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for verbleib_typ field
            //
            $column = new TextViewColumn('verbleib_typ', 'verbleib_typ', 'Verbleib Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_typ_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for verbleib_text field
            //
            $column = new TextViewColumn('verbleib_text', 'verbleib_text', 'Verbleib Text', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_text_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for herkunft_name field
            //
            $column = new TextViewColumn('herkunft_name', 'herkunft_name', 'Herkunft Name', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_name_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for verbleib_name field
            //
            $column = new TextViewColumn('verbleib_name', 'verbleib_name', 'Verbleib Name', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_name_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for buchung field
            //
            $column = new TextViewColumn('buchung', 'buchung', 'Buchung', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_buchung_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for gtin field
            //
            $column = new TextViewColumn('gtin', 'gtin', 'Gtin', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_gtin_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for g_gn field
            //
            $column = new TextViewColumn('g_gn', 'g_gn', 'G Gn', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_g_gn_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for kontamination field
            //
            $column = new TextViewColumn('kontamination', 'kontamination', 'Kontamination', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_kontamination_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for herkunft_vtyp field
            //
            $column = new TextViewColumn('herkunft_vtyp', 'herkunft_vtyp', 'Herkunft Vtyp', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_vtyp_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for herkunft_vtext field
            //
            $column = new TextViewColumn('herkunft_vtext', 'herkunft_vtext', 'Herkunft Vtext', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_vtext_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for verbleib_vtyp field
            //
            $column = new TextViewColumn('verbleib_vtyp', 'verbleib_vtyp', 'Verbleib Vtyp', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_vtyp_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for verbleib_vtext field
            //
            $column = new TextViewColumn('verbleib_vtext', 'verbleib_vtext', 'Verbleib Vtext', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_vtext_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for herkunft_strasse field
            //
            $column = new TextViewColumn('herkunft_strasse', 'herkunft_strasse', 'Herkunft Strasse', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_strasse_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for herkunft_strasse_nr field
            //
            $column = new TextViewColumn('herkunft_strasse_nr', 'herkunft_strasse_nr', 'Herkunft Strasse Nr', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_strasse_nr_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for herkunft_land field
            //
            $column = new TextViewColumn('herkunft_land', 'herkunft_land', 'Herkunft Land', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_land_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for herkunft_plz field
            //
            $column = new TextViewColumn('herkunft_plz', 'herkunft_plz', 'Herkunft Plz', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_plz_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for herkunft_ort field
            //
            $column = new TextViewColumn('herkunft_ort', 'herkunft_ort', 'Herkunft Ort', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_ort_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for verbleib_strasse field
            //
            $column = new TextViewColumn('verbleib_strasse', 'verbleib_strasse', 'Verbleib Strasse', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_strasse_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for verbleib_strasse_nr field
            //
            $column = new TextViewColumn('verbleib_strasse_nr', 'verbleib_strasse_nr', 'Verbleib Strasse Nr', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_strasse_nr_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for verbleib_land field
            //
            $column = new TextViewColumn('verbleib_land', 'verbleib_land', 'Verbleib Land', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_land_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for verbleib_plz field
            //
            $column = new TextViewColumn('verbleib_plz', 'verbleib_plz', 'Verbleib Plz', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_plz_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for verbleib_ort field
            //
            $column = new TextViewColumn('verbleib_ort', 'verbleib_ort', 'Verbleib Ort', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_ort_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA3', 'Report Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_LA3_handler_print');
            $grid->AddPrintColumn($column);
        }
    
        protected function AddExportColumns(Grid $grid)
        {
            //
            // View column for periode field
            //
            $column = new TextViewColumn('periode', 'periode', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_periode_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for buchungsart field
            //
            $column = new TextViewColumn('buchungsart', 'buchungsart', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_buchungsart_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for sn field
            //
            $column = new TextViewColumn('sn', 'sn', 'Sn', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_sn_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for sp field
            //
            $column = new TextViewColumn('sp', 'sp', 'Sp', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_sp_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for abfallart field
            //
            $column = new TextViewColumn('abfallart', 'abfallart', 'Abfallart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_abfallart_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for masse field
            //
            $column = new NumberViewColumn('masse', 'masse', 'Masse', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(0);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddExportColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('herkunft', 'LA1', 'Herkunft', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_LA1_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for herkunft_typ field
            //
            $column = new TextViewColumn('herkunft_typ', 'herkunft_typ', 'Herkunft Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_typ_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for herkunft_text field
            //
            $column = new TextViewColumn('herkunft_text', 'herkunft_text', 'Herkunft Text', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_text_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('verbleib', 'LA2', 'Verbleib', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_LA2_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for verbleib_typ field
            //
            $column = new TextViewColumn('verbleib_typ', 'verbleib_typ', 'Verbleib Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_typ_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for verbleib_text field
            //
            $column = new TextViewColumn('verbleib_text', 'verbleib_text', 'Verbleib Text', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_text_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for herkunft_name field
            //
            $column = new TextViewColumn('herkunft_name', 'herkunft_name', 'Herkunft Name', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_name_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for verbleib_name field
            //
            $column = new TextViewColumn('verbleib_name', 'verbleib_name', 'Verbleib Name', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_name_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for buchung field
            //
            $column = new TextViewColumn('buchung', 'buchung', 'Buchung', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_buchung_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for gtin field
            //
            $column = new TextViewColumn('gtin', 'gtin', 'Gtin', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_gtin_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for g_gn field
            //
            $column = new TextViewColumn('g_gn', 'g_gn', 'G Gn', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_g_gn_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for kontamination field
            //
            $column = new TextViewColumn('kontamination', 'kontamination', 'Kontamination', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_kontamination_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for herkunft_vtyp field
            //
            $column = new TextViewColumn('herkunft_vtyp', 'herkunft_vtyp', 'Herkunft Vtyp', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_vtyp_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for herkunft_vtext field
            //
            $column = new TextViewColumn('herkunft_vtext', 'herkunft_vtext', 'Herkunft Vtext', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_vtext_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for verbleib_vtyp field
            //
            $column = new TextViewColumn('verbleib_vtyp', 'verbleib_vtyp', 'Verbleib Vtyp', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_vtyp_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for verbleib_vtext field
            //
            $column = new TextViewColumn('verbleib_vtext', 'verbleib_vtext', 'Verbleib Vtext', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_vtext_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for herkunft_strasse field
            //
            $column = new TextViewColumn('herkunft_strasse', 'herkunft_strasse', 'Herkunft Strasse', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_strasse_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for herkunft_strasse_nr field
            //
            $column = new TextViewColumn('herkunft_strasse_nr', 'herkunft_strasse_nr', 'Herkunft Strasse Nr', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_strasse_nr_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for herkunft_land field
            //
            $column = new TextViewColumn('herkunft_land', 'herkunft_land', 'Herkunft Land', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_land_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for herkunft_plz field
            //
            $column = new TextViewColumn('herkunft_plz', 'herkunft_plz', 'Herkunft Plz', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_plz_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for herkunft_ort field
            //
            $column = new TextViewColumn('herkunft_ort', 'herkunft_ort', 'Herkunft Ort', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_ort_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for verbleib_strasse field
            //
            $column = new TextViewColumn('verbleib_strasse', 'verbleib_strasse', 'Verbleib Strasse', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_strasse_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for verbleib_strasse_nr field
            //
            $column = new TextViewColumn('verbleib_strasse_nr', 'verbleib_strasse_nr', 'Verbleib Strasse Nr', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_strasse_nr_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for verbleib_land field
            //
            $column = new TextViewColumn('verbleib_land', 'verbleib_land', 'Verbleib Land', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_land_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for verbleib_plz field
            //
            $column = new TextViewColumn('verbleib_plz', 'verbleib_plz', 'Verbleib Plz', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_plz_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for verbleib_ort field
            //
            $column = new TextViewColumn('verbleib_ort', 'verbleib_ort', 'Verbleib Ort', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_ort_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA3', 'Report Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_LA3_handler_export');
            $grid->AddExportColumn($column);
        }
    
        private function AddCompareColumns(Grid $grid)
        {
            //
            // View column for periode field
            //
            $column = new TextViewColumn('periode', 'periode', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_periode_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for buchungsart field
            //
            $column = new TextViewColumn('buchungsart', 'buchungsart', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_buchungsart_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for sn field
            //
            $column = new TextViewColumn('sn', 'sn', 'Sn', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_sn_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for abfallart field
            //
            $column = new TextViewColumn('abfallart', 'abfallart', 'Abfallart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_abfallart_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for masse field
            //
            $column = new NumberViewColumn('masse', 'masse', 'Masse', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(0);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddCompareColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('herkunft', 'LA1', 'Herkunft', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_LA1_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for herkunft_typ field
            //
            $column = new TextViewColumn('herkunft_typ', 'herkunft_typ', 'Herkunft Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_typ_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('verbleib', 'LA2', 'Verbleib', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_LA2_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for verbleib_typ field
            //
            $column = new TextViewColumn('verbleib_typ', 'verbleib_typ', 'Verbleib Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_typ_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for buchung field
            //
            $column = new TextViewColumn('buchung', 'buchung', 'Buchung', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_buchung_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for gtin field
            //
            $column = new TextViewColumn('gtin', 'gtin', 'Gtin', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_gtin_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for sp field
            //
            $column = new TextViewColumn('sp', 'sp', 'Sp', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_sp_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for g_gn field
            //
            $column = new TextViewColumn('g_gn', 'g_gn', 'G Gn', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_g_gn_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for kontamination field
            //
            $column = new TextViewColumn('kontamination', 'kontamination', 'Kontamination', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_kontamination_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for herkunft_text field
            //
            $column = new TextViewColumn('herkunft_text', 'herkunft_text', 'Herkunft Text', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_text_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for herkunft_vtyp field
            //
            $column = new TextViewColumn('herkunft_vtyp', 'herkunft_vtyp', 'Herkunft Vtyp', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_vtyp_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for herkunft_vtext field
            //
            $column = new TextViewColumn('herkunft_vtext', 'herkunft_vtext', 'Herkunft Vtext', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_vtext_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for verbleib_text field
            //
            $column = new TextViewColumn('verbleib_text', 'verbleib_text', 'Verbleib Text', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_text_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for verbleib_vtyp field
            //
            $column = new TextViewColumn('verbleib_vtyp', 'verbleib_vtyp', 'Verbleib Vtyp', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_vtyp_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for verbleib_vtext field
            //
            $column = new TextViewColumn('verbleib_vtext', 'verbleib_vtext', 'Verbleib Vtext', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_vtext_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for herkunft_name field
            //
            $column = new TextViewColumn('herkunft_name', 'herkunft_name', 'Herkunft Name', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_name_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for herkunft_strasse field
            //
            $column = new TextViewColumn('herkunft_strasse', 'herkunft_strasse', 'Herkunft Strasse', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_strasse_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for herkunft_strasse_nr field
            //
            $column = new TextViewColumn('herkunft_strasse_nr', 'herkunft_strasse_nr', 'Herkunft Strasse Nr', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_strasse_nr_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for herkunft_land field
            //
            $column = new TextViewColumn('herkunft_land', 'herkunft_land', 'Herkunft Land', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_land_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for herkunft_plz field
            //
            $column = new TextViewColumn('herkunft_plz', 'herkunft_plz', 'Herkunft Plz', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_plz_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for herkunft_ort field
            //
            $column = new TextViewColumn('herkunft_ort', 'herkunft_ort', 'Herkunft Ort', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_herkunft_ort_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for verbleib_name field
            //
            $column = new TextViewColumn('verbleib_name', 'verbleib_name', 'Verbleib Name', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_name_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for verbleib_strasse field
            //
            $column = new TextViewColumn('verbleib_strasse', 'verbleib_strasse', 'Verbleib Strasse', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_strasse_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for verbleib_strasse_nr field
            //
            $column = new TextViewColumn('verbleib_strasse_nr', 'verbleib_strasse_nr', 'Verbleib Strasse Nr', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_strasse_nr_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for verbleib_land field
            //
            $column = new TextViewColumn('verbleib_land', 'verbleib_land', 'Verbleib Land', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_land_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for verbleib_plz field
            //
            $column = new TextViewColumn('verbleib_plz', 'verbleib_plz', 'Verbleib Plz', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_plz_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for verbleib_ort field
            //
            $column = new TextViewColumn('verbleib_ort', 'verbleib_ort', 'Verbleib Ort', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_verbleib_ort_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA3', 'Report Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_qedm_resultGrid_LA3_handler_compare');
            $grid->AddCompareColumn($column);
        }
    
        private function AddCompareHeaderColumns(Grid $grid)
        {
    
        }
    
        public function GetPageDirection()
        {
            return null;
        }
    
        public function isFilterConditionRequired()
        {
            return true;
        }
    
        protected function ApplyCommonColumnEditProperties(CustomEditColumn $column)
        {
            $column->SetDisplaySetToNullCheckBox(false);
            $column->SetDisplaySetToDefaultCheckBox(false);
    		$column->SetVariableContainer($this->GetColumnVariableContainer());
        }
    
        function GetCustomClientScript()
        {
            return ;
        }
        
        function GetOnPageLoadedClientScript()
        {
            return ;
        }
    
        protected function CreateGrid()
        {
            $result = new Grid($this, $this->dataset);
            if ($this->GetSecurityInfo()->HasDeleteGrant())
               $result->SetAllowDeleteSelected(false);
            else
               $result->SetAllowDeleteSelected(false);   
            
            ApplyCommonPageSettings($this, $result);
            
            $result->SetUseImagesForActions(true);
            $defaultSortedColumns = array();
            $defaultSortedColumns[] = new SortColumn('periode', 'DESC');
            $defaultSortedColumns[] = new SortColumn('buchungsart', 'ASC');
            $result->setDefaultOrdering($defaultSortedColumns);
            $result->SetUseFixedHeader(false);
            $result->SetShowLineNumbers(false);
            $result->SetShowKeyColumnsImagesInHeader(false);
            $result->SetViewMode(ViewMode::TABLE);
            $result->setEnableRuntimeCustomization(true);
            $result->setAllowCompare(true);
            $this->AddCompareHeaderColumns($result);
            $this->AddCompareColumns($result);
            $result->setMultiEditAllowed($this->GetSecurityInfo()->HasEditGrant() && false);
            $result->setTableBordered(false);
            $result->setTableCondensed(false);
            
            $result->SetHighlightRowAtHover(false);
            $result->SetWidth('');
            $this->AddOperationsColumns($result);
            $this->AddFieldColumns($result);
            $this->AddSingleRecordViewColumns($result);
            $this->AddEditColumns($result);
            $this->AddMultiEditColumns($result);
            $this->AddInsertColumns($result);
            $this->AddPrintColumns($result);
            $this->AddExportColumns($result);
            $this->AddMultiUploadColumn($result);
    
    
            $this->SetShowPageList(true);
            $this->SetShowTopPageNavigator(true);
            $this->SetShowBottomPageNavigator(true);
            $this->setPrintListAvailable(true);
            $this->setPrintListRecordAvailable(false);
            $this->setPrintOneRecordAvailable(true);
            $this->setAllowPrintSelectedRecords(true);
            $this->setExportListAvailable(array('pdf', 'excel', 'word', 'xml', 'csv'));
            $this->setExportSelectedRecordsAvailable(array('pdf', 'excel', 'word', 'xml', 'csv'));
            $this->setExportListRecordAvailable(array());
            $this->setExportOneRecordAvailable(array('pdf', 'excel', 'word', 'xml', 'csv'));
    
            return $result;
        }
     
        protected function setClientSideEvents(Grid $grid) {
    
        }
    
        protected function doRegisterHandlers() {
            //
            // View column for periode field
            //
            $column = new TextViewColumn('periode', 'periode', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_periode_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for buchungsart field
            //
            $column = new TextViewColumn('buchungsart', 'buchungsart', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_buchungsart_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for sn field
            //
            $column = new TextViewColumn('sn', 'sn', 'Sn', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_sn_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for abfallart field
            //
            $column = new TextViewColumn('abfallart', 'abfallart', 'Abfallart', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_abfallart_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('herkunft', 'LA1', 'Herkunft', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_LA1_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_typ field
            //
            $column = new TextViewColumn('herkunft_typ', 'herkunft_typ', 'Herkunft Typ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_typ_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('verbleib', 'LA2', 'Verbleib', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_LA2_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_typ field
            //
            $column = new TextViewColumn('verbleib_typ', 'verbleib_typ', 'Verbleib Typ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_typ_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA3', 'Report Gln', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_LA3_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for periode field
            //
            $column = new TextViewColumn('periode', 'periode', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_periode_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for buchungsart field
            //
            $column = new TextViewColumn('buchungsart', 'buchungsart', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_buchungsart_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for sn field
            //
            $column = new TextViewColumn('sn', 'sn', 'Sn', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_sn_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for sp field
            //
            $column = new TextViewColumn('sp', 'sp', 'Sp', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_sp_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for abfallart field
            //
            $column = new TextViewColumn('abfallart', 'abfallart', 'Abfallart', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_abfallart_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('herkunft', 'LA1', 'Herkunft', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_LA1_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_typ field
            //
            $column = new TextViewColumn('herkunft_typ', 'herkunft_typ', 'Herkunft Typ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_typ_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_text field
            //
            $column = new TextViewColumn('herkunft_text', 'herkunft_text', 'Herkunft Text', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_text_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('verbleib', 'LA2', 'Verbleib', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_LA2_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_typ field
            //
            $column = new TextViewColumn('verbleib_typ', 'verbleib_typ', 'Verbleib Typ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_typ_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_text field
            //
            $column = new TextViewColumn('verbleib_text', 'verbleib_text', 'Verbleib Text', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_text_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_name field
            //
            $column = new TextViewColumn('herkunft_name', 'herkunft_name', 'Herkunft Name', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_name_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_name field
            //
            $column = new TextViewColumn('verbleib_name', 'verbleib_name', 'Verbleib Name', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_name_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for buchung field
            //
            $column = new TextViewColumn('buchung', 'buchung', 'Buchung', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_buchung_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for gtin field
            //
            $column = new TextViewColumn('gtin', 'gtin', 'Gtin', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_gtin_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for g_gn field
            //
            $column = new TextViewColumn('g_gn', 'g_gn', 'G Gn', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_g_gn_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for kontamination field
            //
            $column = new TextViewColumn('kontamination', 'kontamination', 'Kontamination', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_kontamination_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_vtyp field
            //
            $column = new TextViewColumn('herkunft_vtyp', 'herkunft_vtyp', 'Herkunft Vtyp', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_vtyp_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_vtext field
            //
            $column = new TextViewColumn('herkunft_vtext', 'herkunft_vtext', 'Herkunft Vtext', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_vtext_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_vtyp field
            //
            $column = new TextViewColumn('verbleib_vtyp', 'verbleib_vtyp', 'Verbleib Vtyp', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_vtyp_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_vtext field
            //
            $column = new TextViewColumn('verbleib_vtext', 'verbleib_vtext', 'Verbleib Vtext', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_vtext_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_strasse field
            //
            $column = new TextViewColumn('herkunft_strasse', 'herkunft_strasse', 'Herkunft Strasse', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_strasse_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_strasse_nr field
            //
            $column = new TextViewColumn('herkunft_strasse_nr', 'herkunft_strasse_nr', 'Herkunft Strasse Nr', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_strasse_nr_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_land field
            //
            $column = new TextViewColumn('herkunft_land', 'herkunft_land', 'Herkunft Land', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_land_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_plz field
            //
            $column = new TextViewColumn('herkunft_plz', 'herkunft_plz', 'Herkunft Plz', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_plz_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_ort field
            //
            $column = new TextViewColumn('herkunft_ort', 'herkunft_ort', 'Herkunft Ort', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_ort_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_strasse field
            //
            $column = new TextViewColumn('verbleib_strasse', 'verbleib_strasse', 'Verbleib Strasse', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_strasse_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_strasse_nr field
            //
            $column = new TextViewColumn('verbleib_strasse_nr', 'verbleib_strasse_nr', 'Verbleib Strasse Nr', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_strasse_nr_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_land field
            //
            $column = new TextViewColumn('verbleib_land', 'verbleib_land', 'Verbleib Land', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_land_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_plz field
            //
            $column = new TextViewColumn('verbleib_plz', 'verbleib_plz', 'Verbleib Plz', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_plz_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_ort field
            //
            $column = new TextViewColumn('verbleib_ort', 'verbleib_ort', 'Verbleib Ort', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_ort_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA3', 'Report Gln', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_LA3_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for periode field
            //
            $column = new TextViewColumn('periode', 'periode', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_periode_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for buchungsart field
            //
            $column = new TextViewColumn('buchungsart', 'buchungsart', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_buchungsart_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for sn field
            //
            $column = new TextViewColumn('sn', 'sn', 'Sn', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_sn_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for abfallart field
            //
            $column = new TextViewColumn('abfallart', 'abfallart', 'Abfallart', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_abfallart_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('herkunft', 'LA1', 'Herkunft', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_LA1_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_typ field
            //
            $column = new TextViewColumn('herkunft_typ', 'herkunft_typ', 'Herkunft Typ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_typ_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('verbleib', 'LA2', 'Verbleib', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_LA2_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_typ field
            //
            $column = new TextViewColumn('verbleib_typ', 'verbleib_typ', 'Verbleib Typ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_typ_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for buchung field
            //
            $column = new TextViewColumn('buchung', 'buchung', 'Buchung', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_buchung_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for gtin field
            //
            $column = new TextViewColumn('gtin', 'gtin', 'Gtin', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_gtin_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for sp field
            //
            $column = new TextViewColumn('sp', 'sp', 'Sp', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_sp_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for g_gn field
            //
            $column = new TextViewColumn('g_gn', 'g_gn', 'G Gn', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_g_gn_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for kontamination field
            //
            $column = new TextViewColumn('kontamination', 'kontamination', 'Kontamination', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_kontamination_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_text field
            //
            $column = new TextViewColumn('herkunft_text', 'herkunft_text', 'Herkunft Text', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_text_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_vtyp field
            //
            $column = new TextViewColumn('herkunft_vtyp', 'herkunft_vtyp', 'Herkunft Vtyp', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_vtyp_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_vtext field
            //
            $column = new TextViewColumn('herkunft_vtext', 'herkunft_vtext', 'Herkunft Vtext', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_vtext_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_text field
            //
            $column = new TextViewColumn('verbleib_text', 'verbleib_text', 'Verbleib Text', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_text_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_vtyp field
            //
            $column = new TextViewColumn('verbleib_vtyp', 'verbleib_vtyp', 'Verbleib Vtyp', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_vtyp_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_vtext field
            //
            $column = new TextViewColumn('verbleib_vtext', 'verbleib_vtext', 'Verbleib Vtext', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_vtext_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_name field
            //
            $column = new TextViewColumn('herkunft_name', 'herkunft_name', 'Herkunft Name', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_name_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_strasse field
            //
            $column = new TextViewColumn('herkunft_strasse', 'herkunft_strasse', 'Herkunft Strasse', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_strasse_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_strasse_nr field
            //
            $column = new TextViewColumn('herkunft_strasse_nr', 'herkunft_strasse_nr', 'Herkunft Strasse Nr', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_strasse_nr_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_land field
            //
            $column = new TextViewColumn('herkunft_land', 'herkunft_land', 'Herkunft Land', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_land_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_plz field
            //
            $column = new TextViewColumn('herkunft_plz', 'herkunft_plz', 'Herkunft Plz', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_plz_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_ort field
            //
            $column = new TextViewColumn('herkunft_ort', 'herkunft_ort', 'Herkunft Ort', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_ort_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_name field
            //
            $column = new TextViewColumn('verbleib_name', 'verbleib_name', 'Verbleib Name', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_name_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_strasse field
            //
            $column = new TextViewColumn('verbleib_strasse', 'verbleib_strasse', 'Verbleib Strasse', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_strasse_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_strasse_nr field
            //
            $column = new TextViewColumn('verbleib_strasse_nr', 'verbleib_strasse_nr', 'Verbleib Strasse Nr', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_strasse_nr_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_land field
            //
            $column = new TextViewColumn('verbleib_land', 'verbleib_land', 'Verbleib Land', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_land_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_plz field
            //
            $column = new TextViewColumn('verbleib_plz', 'verbleib_plz', 'Verbleib Plz', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_plz_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_ort field
            //
            $column = new TextViewColumn('verbleib_ort', 'verbleib_ort', 'Verbleib Ort', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_ort_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA3', 'Report Gln', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_LA3_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_qedm_result_herkunft_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_qedm_result_verbleib_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_qedm_result_report_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_qedm_result_herkunft_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_qedm_result_verbleib_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_qedm_result_report_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for periode field
            //
            $column = new TextViewColumn('periode', 'periode', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_periode_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for buchungsart field
            //
            $column = new TextViewColumn('buchungsart', 'buchungsart', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_buchungsart_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for sn field
            //
            $column = new TextViewColumn('sn', 'sn', 'Sn', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_sn_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for sp field
            //
            $column = new TextViewColumn('sp', 'sp', 'Sp', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_sp_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for abfallart field
            //
            $column = new TextViewColumn('abfallart', 'abfallart', 'Abfallart', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_abfallart_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('herkunft', 'LA1', 'Herkunft', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_LA1_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_typ field
            //
            $column = new TextViewColumn('herkunft_typ', 'herkunft_typ', 'Herkunft Typ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_typ_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_text field
            //
            $column = new TextViewColumn('herkunft_text', 'herkunft_text', 'Herkunft Text', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_text_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('verbleib', 'LA2', 'Verbleib', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_LA2_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_typ field
            //
            $column = new TextViewColumn('verbleib_typ', 'verbleib_typ', 'Verbleib Typ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_typ_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_text field
            //
            $column = new TextViewColumn('verbleib_text', 'verbleib_text', 'Verbleib Text', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_text_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_name field
            //
            $column = new TextViewColumn('herkunft_name', 'herkunft_name', 'Herkunft Name', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_name_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_name field
            //
            $column = new TextViewColumn('verbleib_name', 'verbleib_name', 'Verbleib Name', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_name_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for buchung field
            //
            $column = new TextViewColumn('buchung', 'buchung', 'Buchung', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_buchung_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for gtin field
            //
            $column = new TextViewColumn('gtin', 'gtin', 'Gtin', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_gtin_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for g_gn field
            //
            $column = new TextViewColumn('g_gn', 'g_gn', 'G Gn', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_g_gn_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for kontamination field
            //
            $column = new TextViewColumn('kontamination', 'kontamination', 'Kontamination', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_kontamination_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_vtyp field
            //
            $column = new TextViewColumn('herkunft_vtyp', 'herkunft_vtyp', 'Herk. Verf. GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_vtyp_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_vtext field
            //
            $column = new TextViewColumn('herkunft_vtext', 'herkunft_vtext', 'Herk. Verf.', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_vtext_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_vtyp field
            //
            $column = new TextViewColumn('verbleib_vtyp', 'verbleib_vtyp', 'Verbl. Verf. GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_vtyp_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_vtext field
            //
            $column = new TextViewColumn('verbleib_vtext', 'verbleib_vtext', 'Verbl. Verf. ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_vtext_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_strasse field
            //
            $column = new TextViewColumn('herkunft_strasse', 'herkunft_strasse', 'Herkunft Strasse', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_strasse_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_strasse_nr field
            //
            $column = new TextViewColumn('herkunft_strasse_nr', 'herkunft_strasse_nr', 'Herkunft Strasse Nr', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_strasse_nr_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_land field
            //
            $column = new TextViewColumn('herkunft_land', 'herkunft_land', 'Herkunft Land', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_land_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_plz field
            //
            $column = new TextViewColumn('herkunft_plz', 'herkunft_plz', 'Herkunft Plz', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_plz_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for herkunft_ort field
            //
            $column = new TextViewColumn('herkunft_ort', 'herkunft_ort', 'Herkunft Ort', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_herkunft_ort_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_strasse field
            //
            $column = new TextViewColumn('verbleib_strasse', 'verbleib_strasse', 'Verbleib Strasse', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_strasse_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_strasse_nr field
            //
            $column = new TextViewColumn('verbleib_strasse_nr', 'verbleib_strasse_nr', 'Verbleib Strasse Nr', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_strasse_nr_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_land field
            //
            $column = new TextViewColumn('verbleib_land', 'verbleib_land', 'Verbleib Land', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_land_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_plz field
            //
            $column = new TextViewColumn('verbleib_plz', 'verbleib_plz', 'Verbleib Plz', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_plz_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for verbleib_ort field
            //
            $column = new TextViewColumn('verbleib_ort', 'verbleib_ort', 'Verbleib Ort', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_verbleib_ort_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA3', 'Report Gln', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_qedm_resultGrid_LA3_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_qedm_result_herkunft_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_qedm_result_verbleib_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_qedm_result_report_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'multi_edit_public_qedm_result_herkunft_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'multi_edit_public_qedm_result_verbleib_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'multi_edit_public_qedm_result_report_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
        }
       
        protected function doCustomRenderColumn($fieldName, $fieldData, $rowData, &$customText, &$handled)
        { 
    
        }
    
        protected function doCustomRenderPrintColumn($fieldName, $fieldData, $rowData, &$customText, &$handled)
        { 
    
        }
    
        protected function doCustomRenderExportColumn($exportType, $fieldName, $fieldData, $rowData, &$customText, &$handled)
        { 
    
        }
    
        protected function doCustomDrawRow($rowData, &$cellFontColor, &$cellFontSize, &$cellBgColor, &$cellItalicAttr, &$cellBoldAttr)
        {
    
        }
    
        protected function doExtendedCustomDrawRow($rowData, &$rowCellStyles, &$rowStyles, &$rowClasses, &$cellClasses)
        {
    
        }
    
        protected function doCustomRenderTotal($totalValue, $aggregate, $columnName, &$customText, &$handled)
        {
    
        }
    
        protected function doCustomDefaultValues(&$values, &$handled) 
        {
    
        }
    
        protected function doCustomCompareColumn($columnName, $valueA, $valueB, &$result)
        {
    
        }
    
        protected function doBeforeInsertRecord($page, &$rowData, $tableName, &$cancel, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doBeforeUpdateRecord($page, $oldRowData, &$rowData, $tableName, &$cancel, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doBeforeDeleteRecord($page, &$rowData, $tableName, &$cancel, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doAfterInsertRecord($page, $rowData, $tableName, &$success, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doAfterUpdateRecord($page, $oldRowData, $rowData, $tableName, &$success, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doAfterDeleteRecord($page, $rowData, $tableName, &$success, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doCustomHTMLHeader($page, &$customHtmlHeaderText)
        { 
    
        }
    
        protected function doGetCustomTemplate($type, $part, $mode, &$result, &$params)
        {
    
        }
    
        protected function doGetCustomExportOptions(Page $page, $exportType, $rowData, &$options)
        {
    
        }
    
        protected function doFileUpload($fieldName, $rowData, &$result, &$accept, $originalFileName, $originalFileExtension, $fileSize, $tempFileName)
        {
    
        }
    
        protected function doPrepareChart(Chart $chart)
        {
    
        }
    
        protected function doPrepareColumnFilter(ColumnFilter $columnFilter)
        {
    
        }
    
        protected function doPrepareFilterBuilder(FilterBuilder $filterBuilder, FixedKeysArray $columns)
        {
    
        }
    
        protected function doGetSelectionFilters(FixedKeysArray $columns, &$result)
        {
    
        }
    
        protected function doGetCustomFormLayout($mode, FixedKeysArray $columns, FormLayout $layout)
        {
    
        }
    
        protected function doGetCustomColumnGroup(FixedKeysArray $columns, ViewColumnGroup $columnGroup)
        {
    
        }
    
        protected function doPageLoaded()
        {
    
        }
    
        protected function doCalculateFields($rowData, $fieldName, &$value)
        {
    
        }
    
        protected function doGetCustomPagePermissions(Page $page, PermissionSet &$permissions, &$handled)
        {
    
        }
    
        protected function doGetCustomRecordPermissions(Page $page, &$usingCondition, $rowData, &$allowEdit, &$allowDelete, &$mergeWithDefault, &$handled)
        {
    
        }
    
    }

    SetUpUserAuthorization();

    try
    {
        $Page = new public_qedm_resultPage("public_qedm_result", "frmActivity_edm_result.php", GetCurrentUserPermissionSetForDataSource("public.qedm_result"), 'UTF-8');
        $Page->SetRecordPermission(GetCurrentUserRecordPermissionsForDataSource("public.qedm_result"));
        GetApplication()->SetMainPage($Page);
        GetApplication()->Run();
    }
    catch(Exception $e)
    {
        ShowErrorPage($e);
    }
	
